-------------------------------------------------------------------------
--
-- Code by Genrall of Ravencrest-US Disillusioned guild
-- http://disillusioned.x10host.com
--
-- forwards.lua - TabardMaster's forward defines file for functions.
--
-- Forward define local variables that will become functions in later 
--	code.  IE:
-- 		local functionname
-- 		[code]
-- 		functionname = function() end

-- LUA has only 8 data types:  nil, boolean, number, string, function, 
--	userdata, thread, and table, and global or local scopes.

-- Local functions need defining in scope before calling the value that
-- 	the function stores.  Data types can be changed by redefining, but
--	redefining as a second local will create a second local.

-- Code version 124 
-- (c) 2011-2017 Disillusioned.  All rights reserved.
--
-------------------------------------------------------------------------




-- Glue functions; generic code
local array_join
-- END of glue functions


-- Profiles & player options
local defaultProfile
local backupProfile
local getGlobalOption
local setGlobalOption
local getPlayerCategory
local getPlayerOption
local getPlayerSetting
local setPlayerCategory
local setPlayerOption
local setPlayerSetting
-- End profile & options functions


-- Chat panel functions
local vprint
local dprint
-- End chat panel functions


-- Standalone functions that call the API
local getItemLink
local TabardOMatic
local getFreeBag
local getCurrentTabard
local NEWgetAllTabards
local gat
local getAllGearsets
-- END of standalone API call functions


-- Options panels & support
local iofOpenPanel
local iofRefresh
local createButton
local createCheckButton
local createSlider
local createTextField
local createFilledPanel
local createGroupWidget
local makeModeOption
-- End option panel & support code


-- Reputation functions
local resetReputationBlock
local getFactionNameFromFactionId
local getTabardFromFactionId
local getFactionIdFromTabard
local getAllegianceFactionId
local setWatchedFactionById
local getAllReputationsByID
local startReputationTimer
local updateReputationBar
--- End Reputation functions


-- Checks & validations
local checkIfGearset
local checkRangedOption
local checkToggleOption
local validateTabard
local validateAllTabards
local validateAllGearsets
-- end Checks & validations


-- Tabard functions
local NEWwearTabard
local isInTabardGroup
local pickRandomTabard
local pickClosestTabard
local pickFurthestTabard
local pickBestTabard
-- End tabard functions
-- Tabards and tabard accessories - old code
local getBestTabard
local getRandomTabard
local vTabard
local pickTabard
-- end Tabards and tabard accessories


-- Gear
local NEWwearGear
-- end Gear
	

--- Mapping functions
local resetZoneChangeBlock
local isInMapType
local isInEnemyCity
local isInFriendlyCity
local isInPvPZone
local isInHome
local getMapType
local NEWzoneDecoder
local zoneChangedEventHandler
local exitCombatEventHandler
local startZonechangeTimer
-- end Mapping functions


-- Option panel displays
local setDisplay
local setUsageState
-- end option panel displays


-- Menus.
local submenuTabards
local submenuEquipment
local quickMenu
local tabardMenu
local gearMenu
-- end Menus


-- Options Panels creation
local createMainPanel
local createInstancePanel
local createGearMasterPanel
local createAdvancedPanel
local createAboutPanel
-- End Options Panels


-- LDB code (These are global functions and do not require forward defining)
--	tm_LDB_OnClick
--	tm_LDB_tooltipShow
---- End LDB code


-- Event driven
local startMeUp
-- end Event driven


local tm_EventHandler
local tm_SlashHandler

--[[ this is used during development only
local function dump(o)
-- display contents of variable, similiar to /dump console command.  Needs work.
	if type(o) == 'table' then
		local s = '{\n'
		for k, v in pairs(o) do
         if type(k) ~= 'number' then k = '"' .. k .. '"'; end
         s = s .. '["' .. k .. '"] = "' .. dump(v) .. '",\n'
      end
      return s .. '}\n'
   else
      return tostring(o)
   end
end
]]

--[[ local function getBagLocation(findItemId)
-- returns bag & bag slot of an item, or nil if not found
	local slotId
	for bagId = NUM_BAG_SLOTS, 0, -1 do
		for slotId = 1, GetContainerNumSlots(bagId) do
			itemId = GetContainerItemID(bagId, slotId)
			if itemId and itemId == findItemId then return bagId, slotId; end
		end
	end
end
]]--