----------------------------------------------------------------------
--
-- Code by Genrall of Ravencrest-US Disillusioned guild
-- http://disillusioned.x10host.com
--
-- tabardmaster.lua - TabardMaster's main code file, please do
-- not edit, make changes in language.lua and custom.lua files
-- as needed.  See those files for instructions.
--
-- Code version 124 release.
-- (c) 2011-2017 Disillusioned.  All rights reserved.
--
--[[------------------------------------------------------------------

Version history
6/12/2011 v0.1 initial code
6/13/2011 v0.2  added enable checkbox for each group type
6/15/2011 v0.3 added verbose mode, finished tabard removal code, added language file
6/17/2011 v0.4 added check for missing tabard, tidied code & reports
6/24/2011 v0.5 code cleanup, lots of testing,
7/02/2011 v0.6 added 'pick' buttons with dropdown menus, enabled '/tm debug' toggle
7/23/2011 v0.7 changed internal tabards to use itemID instead of itemLink, renamed several routines
7/24/2011 v0.7b fixed if-then structure in wrong place causing lua error
7/29/2011 v0.80 Major code rewrite & reorganization!  Added faction reputation indicators per group.  Added quick change
	options "/tm n|p|r|v".  Changed initialization routine from VARIABLES_LOADED event to ADDON_LOADED event.
	Added "/tm ?|help" display.  Added 'ready' message.  Old iLink style stored tabards now converted.
8/03/2011 v081 Omitted code to save tabards from the drop down menu, oops.
8/12/2011 v082 New group decoder, includes world pvp zones.  Reworked saved variables decoder,  tweaked command decoder.  Added
	status for most recent tabard change - see with "/rg status".
09/08/2011 v083 Added /q quiet option
09/18/2011 v084 Added /d disable (and /e enable) option, some internal variables renamed and routines relocated
09/25/2011 v085 Implemented 'Ok' and 'Cancel' functions of option panel.  Renamed saved variables,  Added hush flag to
	stop 'tabard is missing' and 'bags full' spam
10/06/2011 v086 Tabards were randomy getting stuck on cursor; don't know why.  Rewrote tabard swapping code.
10/14/2011 v087 added random tabard and /rnd option.  more spam prevention.
10/29/2011 v088 fixed obscure error when prepping a tabard, arranged tabards into categories for next version
12/12/2011 v089 Major rewrite; "Normal" tabard group is now "Solo" tabard group; "Party" is now
	"Dungeon".  Added option to temporarily swap tabard to a guild tabard when turning in quests.
	Changed 'set tabard' button to 'pick tabard' menu button, 'pick tabard' button replaced with 'pick category'
	menu button.  tm /off, /on, & /o disables,  enables, and toggles TabardMaster functionality, respctively,
	instead of /e & /d.  Removed internal optionStatus variable, status line (in options panel) is always enabled
 	now.  Gender specific reputation texts (for non enUS clients) Removed enable check boxes for group types
	& several internal variables.  Added custom.lua as optional file.  Updated for client version 4.3.0.  Checkboxes
 	for each group type removed.  New tabard swap spam reduction method.
12/18/2011 v090 new tabard category "guild ".  Changed 'solo' to 'none' & 'dungeon' to 'party' in party
	decoding routines to match WoW's cient; caused dungeon tabards to not be equipped consistently.  Hard
	coded instances as the client returned instance names are inconsistent, added 'please help' message for "new"
	instances.  Added WoWACE's Zone & Faction translation libraries to reduce # of needed translations.
12/26/2011 v091 Fixed lua error if custom.lua not installed
01/05/2012 v092 Added new "City" tabard group; disabled unused tabard categories, 'city' tabard category is now
	'cities' internally.  Partial rewrite of "era" decoding.  Fixed tabard save typos.  'No Tabard' setting no
	longer causes lua error if not wearing a tabard.  Darkmoon Island is listed as neutral city.  "New" instances
	recorded and erased after incorporating.
01/15/2012 v093 Corrrected library initialization code.
01/25/2012 094 Added throttle to swapping tabards via zone changes, fixed error if tabard chosen is already worn at login.
	Stopped swap spam when turning in a quest if guild tabard already worn.  Illustrious Guild Tabard will
	now be equipped at quest turn-ins
04/14/2012 095 stopped allowing tabard swaps during combat to prevent cursor issues, added "dungeons" panel to match
	tabards to dungeons from different game expansions. (Main panel is for solo, city, raid, & pvp.)  New tabard
	options "auto", "faction", "closest" and "furthest".  Lots of internal changes.  Enemy cities are classified as pvp zones.
04/15/2012 095b Fixed new installs from getting nil comparison error
05/06/2012 096 Added more tabard options to instance tabards, reworked debug only mode slash options.  Added arenas
	& battlegrounds to instance table.  Added separators to popup menus.  More changes to tabardDecoder function.
	Burning Crusades era Caverns of Time instance definitions updated.  Built-in texts for Instance panel moved to
	language translation table, added personalized translator entry to About panel.  Added option to change watched
	faction to match current tabard if appropriate.  Added check for newly exalted reputations; SHOULD trigger tabard
	changes mid-instance.
07/03/2012 097 Added definable color entries to menu titles & action verbs.  Improved instance decoding; tabards
	were being swapped up to 4 times when exiting a dungeon.  All dungeons now have own entries again.
	Ironforge -> City of Ironforge.  Code migrated from group based to location based tabard decisions.  Tweaked
 	look of popup menus.  New saved options & tabards format.  New tabard selection routines, with player
	over-ridable entries.  (needs editor though)  Major changes to the auto 'faction' code.  Added 'reputation' button
	that toggles the default UI reputation panel's visible status.  "Old World" dungeons are now "classic" dungeons.
08/05/2012 097b fixed 'no tabard' changing to 'auto' at character load, added 2nd checkbox to verbose & tracker
	options, revised version checking in ADDON_LOADED code.  Tweaked rep bar code when completing quests.
08/11/2012 097c "faction" rep wasn't being updated in getAllReputations().  Caressed option upgrading code,
	fixed typo in tabards for quest turn-in & added an abort after 1st tabard located.
08/26/2012 097d BC raid "The Eye" is now "Tempest Keep".  Defunct add-on GearMaster is now an option panel
	that uses a new location mapping technique that will eventually replace the existing one.  zoneSwap option no longer
	prevents city tabard swaps.
11/15/2012 098 Client version 5 compatible.  Removed dependance on LibBabble-Zone library; now all zones and instances
	use MapId for decoding.  Reworked menu generation code (more menu changes coming) and added minimap button.
	Removed old variable storage methods & associated code.  Renamed some variables.  "tm /reset" added.  Fixed
	'defaults' for options panels.
11/18/2012 099 Fixed 'select tabard' buttons.  Fixed 'Do not change tabard' lua error in instance menu.  Replaced
	tablecopy() function with one that actually works properly; sub tables weren't getting copied.
11/26/2012 100 Improved tabard validation methods.  Added code to force item caching when add-on loads.
	Disabled development reports inadvertently left active.  Specific tabards from 'Select Tabard' button now work properly.
12/02/2012 101 Guild tabards weren't swapping properly if wearing best guild tabard and 2nd guild tabard in inventory.
	Fixed lua error in PLAYER_LEAVING_WORLD function; had variable declaration out of sequence.
12/09/2012 102 Some options were always on regardless of setting.  "New" zones were being prematurely removed.
	Rearranged & sped up event handler code; some needed info wasn't being updated if add-on was disabled.
	Code changes to "new" zone storage method.
03/12/2013 103 Updated allegiance logic in normal Lich King dungeons.  Ending combat will now finish any tabard and
	gearset changes that were delayed by combat.  Zone changes causing a tabard swap are less frequent.  Added
	add-on chat functionality.  Fixed lua error when enabling option panel buttons by leveling. Gearset and tabards icons
	now appear in the menus.  Completely new handling of "new" zone discovery and updating.  All known zones as of
	client version 5.2.0 have been categorized; normal zones, cities, battlegrounds, PvP areas, dungeons, raids, and
	scenarios.  Lich King dungeons are decoded properly for all level characters.  Minimap button added with a quick
	change menu.  Added pop-up alert if new version exists.
04/15/2013 104 Tweaks to "new exalted" and level 80 dungeons in "auto" mode.  Updated list of dungeons that do not
	require heroic mode to champion in.  Gear can be swapped by LFG role in the GearMaster panel.  Simplified D80
	faction code.  AddOn chat functions removed.  Battleground & scenarios from patch 5.3 added to
	mapIDlist.lua.  Logging system revised, should be used in development situations only.  "/tm logreset" to reset.
	Added a (hopefully temporary) workaround to a bug in UI version where InterfaceOptionsFrame_OpenToCategory(panel)
	calls fail.  Fixed custom tabard textures in menus & defaulted them to 'on'.  Change state with '/tm textures'.
7/28/2013 105  Pandaria dungeons champion Cataclysm factions by default.
9/28/2013 106 InterfaceOptionsFrame buttons, checkbuttons, textfields (and panels) now use generic creation code.
	Improved alignment (SmartAlign) between widget buttons and checkbuttons, and accompanying text.  Main options panel
	'Select  tabard' and 'Select Category' button menus combined.  Reputation displays repositioned & updated.
	Some internal variable renaming.  Tweaked popup menu code.  Changed file storage of minimap option to match 0|1 style.
	Preliminary code for next expansion (#5) added; not finalized and probably incomplete.
12/26/2013 107 Updated function calls when event UPDATE_FACTION fires; was still set for older versions.  Tweaked
	decoding of options.  Finalized coding of D85 tabards used in D90 instances.  MapID 9000 assigned to all arenas; I do not
	do arena battles so have no idea if the "classic" decoding style worked, and have never received feedback about TM in arenas.
	DeepRun Tram (mapID 922) moved from PvP zone to Classic dungeon zone (Brawlers Guild)
02/15/2014 108 added 'AlwaysPVP' option.  Isle of Thunder (928) & Isle of Giants (929) moved from PvP to Pandaria PvE zone.
	Darkmoon Island (923) moved from neutral cities to Cataclysm PvE.  Tweaked arena code so entering an arena will always
	trigger a tabard and/or gear change.  FactionIDs have been added to several API functions; changed internal data
	structures to use them.  Reputation bar should track tabards better.  tabardDecoder() renamed pickTabard().  All
	lookup tables merged into lookups.lua, except for textureXRef.lua which is a throwback to Tabard-O-Matic addon.
	Button and checkbox sizes and group spacing can be overridden in the language file to help 	with translations.  Babble
	Translation library has been removed.  Internal marker for no gearset tracking renamed from 'nogear' to 'DoNOTchangeGear';
 	hopefully some joker won't name a gearset that.  Gearsets sharing same name but mixed case now treated as individual gearsets.
03/21/2014 109 Changed way LFG role gearsets work; LFG gearsets now take priority over zone gearsets and no longer require 
	'do not change' to be enabled.  tm_lang{} entries received updates and several entries renamed; better commenting for 
	translators.  Text for reputation rankings can be overridden in tm_lang{} for translators.  'Enabled' checkboxs added 
	to main options panel for tabard and gearset swaps.  r4 fixed typo preventing 5 man dungeon groups from getting a tabard change.
05/26/2014 110 Added a cancel entry to bottom of menus.  Fixed gearsets not swapping for anything but LFG queues.  Changed
	'footprints' global zone tracker from development to hidden option.  (/tm footprints)  Added slash options for tabard and 
	gearset swaps.  Rearranged checks & processing order for changed versions of addon or client.  Disabled option and tabard slash 
	commands for later removal as they're now available through the minimap icon.
06/16/2014 111 Needed a tonumber() function in the maxMapIds calculations of mapDecoder().  Added pet battle gearset.  Added
	checks for redefined tabard categories and for gearsets actually existing.  Added overides array to custom.lua.  Changed
	quest turn-in code to use optional custom guild tabard category.  Added custom tabard categories to quick change menu.  Added 
	'cancel' to menus.
10/13/2014 112 Updated for WoD beta.  Raids will show their faction in the reputation bar if the raid has one, and player is 
	not exalted with it, and tracking option is 1.
10/15/2014 113 Added extra DifficultyIDs added in patch 6.0.2 to ZoneDecoder()
10/19/2014 114 Safari Hats are no longer wearable hats (why?) but provide a buff instead, so stripped out pet battle 
	gearset functionality.  Removed code (used in the beta) to enable WoD mode.  Changed default minimap button location from 135 
	to 330.  Added WoD tabards to tm_tabardGroup lookups table.  Stormshield and Warspear remapped into faction city zones.
	custom.lua now distributed as custom.example.lua to prevent overwriting custom changes, and allows mapID reassignment.
	Blackrock Foundry and Highmaul raids moved from Draenor PvE category to Draenor Raids.  Global tracking of major city 
	reputation disabled.
06/08/2015 115 Added new raid zones & updated for game version 6.2.0.  
06/08/2015 116 Corrected immediate closing of faction reputations, hack job.
07/24/2015 117 Changed reputation gathering code to gather only recognized factions instead of using factions listed in UI 
	reputation panel.
09/05/2015 118 Major code rewrite.  Added LDB support including minimap icon.  New: tabard and gearset options for garrisons.  
	New zone decoder.  Changed 'alwaysPVP' option to 'wearPvP' and is now to wear PvP gear in PvE zones if flagged PvP.  
	Changed 1/0 options to be true/false and renamed toggle options; 0/1/2 options now called mode options.  New text for 
	some tooltips and menu selections.  Ashran now PvP zone.  tm_player['newZone'] moved to tm_player['options']['newZone'].  
	Removed maxMapIds & maxFactions auto-incrementers.  Character profile version # changed to use addon version #.  Removed 
	logging debug option.  MAXFACTIONS now internal constant.  Delays added to UPDATE_FACTION and ZONE_CHANGE events, zone
	changes trigger off of chat channel changes and not actual zone changes.  Running into variable count limits; had to 
	convert constants to tm_constants{} array.  All option panels variables now contained in tm_widgets{} array.  
118 ß versions - Fixes for Legion
ß70 Gearset icons no longer are path and filename but textureID
ß71 Info panel defaults to off, addon released as beta
ß72 Disabled reputation change event audio alert, Legion tabard text lines were not showing, Legion dungeon tabards default to 'auto'
ß73 Tabards shown as itemlinks in chat window when changing / removing instead of itemID.  Fixed gearset buttons.
ß74 Changed all tabard & gear displays to single line with embedded line breaks, combined profile ['tabards'] and ['gearset] 
		store to profile['user']; tabard categories get 'Tabard' appended & gear categories get 'Gear' appended, EXCEPT
		for the LFG entries.  Reformatted internal storage of option panel configuration, tabard and gear groups now procedurally 
		generated.  Started rewriting menu code.
ß75, 76 Not released, menu test versions.
119 (AKA ß77) Added session lockout (/tm lock [on|off]).  Fixed lua error when reputation went exalted.  Selection buttons rolled 
		into setDisplay() routine.  Added 'use' entry to widgets; updated with level ups & is used for displaying 'unavailable at 
		your current level' instead of relying on enabled state of button, which is independant.  Minimum level for LK 
		dungeons changed to 68, was 69.  Removed some old comment disabled code. Corrected typo in mmIconBuffer definition.
		Updates to tm_maps; disabled scenario entries.
120 ß1 Removed our tableCopy() function in favor of game's CopyTable() one.  New menu code implemented, old menu code & variables 
		share tm_constants[menuColor entries.
	ß2 Converted remaining tm_lang['menuColor ... entries to tm_constants['menuColor ... equivalents.  Changed format of 
		'/tm p2' test menu to use table.append instead of [x] = {} assignments for testing new menu system.  tmZoneFrame renamed 
		to tmInfoFrame.  Fixed itemID typo (in lookups.lua) for Illustrious Guild Tabard in guild tabards collection.
	ß3 Initial quick change menu code implemented.  Need to change NEWgetAllTabards to return table similar to NEWgetAllGearsets 
		instead of simple array.  Need to remove alternate texture code from same function & leave it in menu code.
	ß4 More menu tampering.  Temporary function gat() returns full tabard info ala getAllGearsets() function, used in new menu code; 
		will probably roll into main codeline later.  Quick menu almost finished, added iofRefresh calls to tabard & gearchange code.
	ß5 Renamed timer & event blocking variables.  Added provision to skip zone change delay (if delay is 0) for eventual slider in 
		options panel.  Gearchanges only swap weapons if in combat, full change still occurs later.  Info frame only created out of
		combat.  (These last 2 elimated UI warnings.)  Renamed "zoneFrame" to "infoFrame" in global store.  Moved timers into 
		character profiles.  Prepped for 'Advanced' UI panel.
121 Changed TOC file for client version 7.2
122 Fixed 'extraVersion' logic ambiguity in main options panel
123 tm_tabardList{}, rawSpacer, rawHeader, rawAction, rawSpecial, & texturePath variables removed.  All menu code converted to new
	style code & old code removed.  Options panel widgets fully procedurally generated and no longer predefined, renamed 'main'
	to 'panel1', etc.  Added missing code to set verbose checkboxes.  Oops.
124 ß1 Reordered code to prevent going exalted raising lua error for missing function; did not work out well with desired function 
		grouping so created ForwardDefines.lua to pre define local functions.  Removed slash function to reset profile.  Fixed
		verbose checkbox code; 2nd checkbox was self resetting and not setting 1st checkbox.
	ß2 Prepped for timer bypass (IE: 0 seconds) and option panel placement.  Added a title option to filled panels; border shares
		same space so not usable yet.
	ß3 Added timers & containing advanced panel, removed footprint tracking & data dump capabilities.  Finished classifying Legion 
		tabards & zones.
	ß4 Captured PLAYER_ENTERING_WORLD event for info frame & player gear change at load
	ß5 Changed all addon self: references to tmFrame: Released as v124.  (Oops, left 2 status messages active & not hidden in debug.)
125 
	


----------------------------------------------------------------------

To-do in current version still
 	more bug checking - always!


Thoughts for later versions
	Shrink code file size!  Split code groups into individual lua files.
	pickBestTabard() needs code from pickTabard() to finish it off, and replace the latter
	Finalize the 'About' panel, add (advanced) editor for categories
	Localizing the status display line - maybe
	Menus use old getAllTabards() code, need converting to NEWgetAllTabards()
	Capture inventory change event & maintain running list of tabards instead of filling array 
		only when changing, will help with speed & above integration.  Maybe use
		UNIT_INVENTORY_CHANGED, BAG_UPDATE, or BAG_UPDATE_DELAYED
		
----------------------------------------------------------------------

Internal storage formats and notes:

tm_global{}
	version - version # of add-on
	options{}
		infoFrame  - true/false; show or hide infoFrame
		infoFrameX - screen X position of infoFrame
		infoFrameY - screen Y position of infoFrame
	exalted{}	
		'47'	= true/false; character has reached exalted with Ironforge
		'54'	= true/false; character has reached exalted with Gnomeregan
		'68'	= true/false; character has reached exalted with Undercity
		'69'	= true/false; character has reached exalted with Darnassus
		'72'	= true/false; character has reached exalted with Stormwind
		'76'	= true/false; character has reached exalted with Orgrimmar
		'81'	= true/false; character has reached exalted with Thunder Bluff
		'530'	= true/false; character has reached exalted with Darkspear Trolls
		'911'	= true/false; character has reached exalted with Silvermoon City
		'930'	= true/false; character has reached exalted with Exodar
		'1133'	= true/false; character has reached exalted with Bilgewater Cartel
		'1134'	= true/false; character has reached exalted with Gilneas
		'1352'	= true/false; character has reached exalted with Pandarian Huojin
		'1353'	= true/false; character has reached exalted with Pandarian Tushui
		
tm_player{} and tm_default{}  profile data
	version - version # of add-on
	options{}
		verbose		Verbose mode off/on (0/1), allow popups (2), debug (3)
		tracker		Reputation bar changes with tabard off/on (0/1) or hides when not championing (2)
		quest		Wear guild tabard when completing quest (true / false)
		zoneSwap	Swap tabard every zone change (true / false)
		textures	Use our custom menu tabard textures or not (true / false)
		LFGrole		Allow gearset changes when LFG que activates (true / false)
		wearPvP		Use PvP tabard & gear if flagged PvP in a PvE zone (true / false)
		tabardswaps	Enable tabard swaps (true / false)
		gearswaps	Enable equipment set swaps (true / false)
		newZone		zone type to use for new (unclassified) zones
		minimap{}
			hide		Hide/Show minimap icon (true/false)
			radius		icon distance from center of minimap frame
			minimapPos	angle of icon in minimap frame, 1-360
		delayReputationChanges	seconds to wait between faction update event firing before processing the event
		blockReputationChanges	seconds to block subsequent reputation change processing
		delayZoneChanges		seconds to wait after changing a zone, to processing the zone change
		blockZoneChanges		seconds to block subsequent zone change processing
	category{}	(tabard category override for each group or dungeon type, really needs the editor implemented)
		solo		preferred tabard category worn in PvE areas
		city		preferred tabard category worn in friendly or sanctuary cities
		raid		preferred tabard category worn in raids
		pvp			preferred tabard category worn in battlegrounds, arenas, & enemy cities
		home		preferred tabard category worn when in garrison or class hall
		misc		preferred "misc" tabard category
		guild		default tabard category for guild tabards
		D60			preferred tabard category worn in old world dungeons
		D70			preferred tabard category worn in Burning Crusades dungeons
		D80			preferred tabard category worn in Lich King dungeons
		D85			preferred tabard category worn in Cataclysm dungeons
		D90			preferred tabard category worn in Mists of Pandaria dungeons
		D100		preferred tabard category worn in Warlords of Draenor dungeons
		D110		preferred tabard category worn in Legion dungeons
	user{}	User tabard and gearset selections to wear in each group type or dungeon
		soloTabard	tabard, category, or mode chosen for PvE zones
		cityTabard	tabard, category, or mode chosen for friendly or sanctuary city zones
		homeTabard	tabard, category, or mode chosen when in garrison or class hall
		raidTabard	tabard, category, or mode chosen for raids
		pvpTabard	tabard, category, or mode chosen for pvp areas & enemy cities
		D60Tabard	tabard, category, or mode chosen for old world dungeons
		D70Tabard	tabard, category, or mode chosen for Burning Crusades dungeons
		D80Tabard	tabard, category, or mode chosen for Lich King dungeons
		D85Tabard	tabard, category, or mode chosen for Cataclysm dungeons
		D90Tabard	tabard, category, or mode chosen for Mists of Pandaria dungeons
		D100Tabard	tabard, category, or mode chosen for Warlords of Draenor dungeons
		D110Tabard	tabard, category, or mode chosen for Legion dungeons
		soloGear	equipment set to wear when in PvE zone
		cityGear	equipment set to wear when in a friendly or sanctuary city
		partyGear	equipment set to wear when in a dungeon / scenario
		homeGear	equipment set to wear when in garrison or class hall
		raidGear	equipment set to wear when in a raid
		pvpGear		equipment set to wear when flagged pvp 
		lfgTANK		equipment set to wear when LFG assigns TANK role
		lfgHEALER	equipment set to wear when LFG assigns HEALER role
		lfgDAMAGER	equipment set to wear when LFG assigns DAMAGER role
		lfgNONE		equipment set to wear when LFG assigns NONE role (scenarios, usually)

profile tabard / category / mode values:
	-1 = do not change tabard for this group type
	0 = wear no tabard
	number > 0 		= a specific tabard
 	"D60tabards" 	= a random classic tabard
 	"D70tabards" 	= a random tabard from Burning Crusades dungeon factions
 	"D80tabards" 	= a random tabard from Lich King dungeon factions
 	"D85tabards" 	= a random tabard from Cataclysm dungeon factions
 	"D90tabards" 	= a random tabard from Pandaria factions
 	"D100tabards" 	= a random tabard from Draenor factions
 	"D110tabards" 	= a random tabard from Legion factions
	"random" 		= a random tabard that matches current dungeon or any random tabard
	"auto" 			= champion the most appropriate faction for the instance entered (see below)
	"closest" 		= champion the faction closest to exalted that we have a tabard for
	"furthest"		= champion the faction furthest from exalted that we have a tabard for
	"faction" 		= Alliance Vanguard or Horde Expedition (the default for the D80/R80 tier)
	anything else 	= a random tabard from a user defined tabard category, interface to be completed "later"

tm_tabardXRef[index] = factionId
  where index is tabard itemId in string form,
		factionId 	= factionId of faction that tabard champions.
Note: Only tabards that champion a faction are listed.  Table is used for quick lookups only.

tm_reputationXRef[index] = {tabard, group, name, ranking, accrued, levelMin, levelMax, levelCur}
   where index is a factionID
		tabard 		= tabard itemId used for championing this faction (only for championing tabards)
		group 		= group assigned to this faction, 'city', D80, etc.  (only for championing tabards)
		name 		= localized name of faction
		ranking		= current reputation ranking with faction, 0-8, see below
			standingID (Reputation ranking) is based on earnedValue:
			0 = unknown
			1 = Hated, 			-21000 	- 	-9001
			2 = Hostile, 		-9000 	- 	-3001
			3 = Unfriendly, 	-3000 	- 	0
			4 = Neutral, 		0 		- 	3000
			5 = Friendly, 		3001 	- 	9000
			6 = Honored, 		9001 	- 	21000
			7 = Revered, 		21001 	- 	42000
			8 = Exalted, 		42001 	- 	42999
		totalRep 	= total reputation with faction, 0 - 42999
		levelMax 	= maximum reputation for current standing
		levelRep 	= current reputation in current standing (totalRep - levelMin)

(This section needs updating to check if any expansions changed old content reputation gains)
The "Auto" tabard strategy for instances:
	Champion cities until character can enter Lich King dungeons
	(Burning Crusades era dungeons grant reputation with faction that "owns" the dungeon, tabards champion no factions)
	Lich King (D80) dungeons champion allegiance until exalted, then a Lich King era faction.
	Heroic LK (H80) dungeons require heroic mode to champion; normal versions will champion a city.
	Cataclysm (D85) dungeons except for Grim Batol and Halls of Origination, will champion a city.
	Grim Batol, Halls of Origination, and all Cataclysm heroic mode dungeons (H80), will champion a Cataclysm faction.
	Mists of Pandaria tabards champion all Cataclysm factions.  (Use the bonus reputation marker in UI.)
	Warlords of Draenor and Legion tabards are vanity items and act as MoP tabards do.


------------------------------------------------------------------]]--


-- Let us begin
local tmTitle = tm_lang['title']												-- Save our name and version number for later use
if GetLocale() == 'enUS' then tmTitle = 'TabardMaster'; end
local tmVersion = GetAddOnMetadata('TabardMaster', 'Version')
local extraVersion = nil; 				 										-- OLIVE OIL!  Nil this entry for release
local tmFrame = CreateFrame('Frame', 'TabardMasterMain', UIParent)				-- Our UI frame
local optionBugFixIOF53 = true													-- Client version 5.3.0 bug marker

-- Global variables (saved variables)
tm_global = {}																	-- general addon stored variables
tm_player = {}																	-- character specific stored variables

-- Our internal variables 
local blockReputationChanges													-- true when UPDATE_FACTION events should be blocked
local blockZoneChanges															-- true when zone change events should be blocked
local tm_reputations = {}														-- Localized reputation texts
local tm_locked = false															-- tabard & gear changes are locked out for this session, 118
local difficultyIndex															-- the difficulty of the current instance (or zone),
local lastMapType = 0															-- keep track of zone we just left
local flagPVP = false															-- PVP flag tracker for 118; follows UnitIsPVP('player')
local tm_backup = {}															-- Backup of tm_player used when option panels cancelled
local instanceName																-- Localized zone (or instance) name
local tmInfoFrame																-- zone info frame (for debugging, /tm info [on|off])
local playerLevel																-- player's character level
local swapGearSet																-- for delayed gearset changes due to combat
local swapTabard      															-- holds tabard to wear after quest or combat
local groupType																	-- Current instance party type (none, party, raid, pvp)
local zoneType																	-- Detailed zone type (solo, instance type, raid, pvp, city)

local mmIcon																	-- LDB minimap icon
local mmIconBuffer = {hide = true, radius = 80, minimapPos = 225}				-- minimap icon LDB buffer

local tm_constants = {
	MAXFACTIONS 		= 400,			-- must be > GetNumFactions() (which changes!) at all times; increment as necessary.
	ARENAMAPID 			= 9000,			-- internal marker for arenas - must match tm_maps['pvp'] entry.  Change as necessary.
	REVERED 			= 7,			-- revered reputation level, have not located game variable
	EXALTED 			= 8,			-- exalted reputation level, have not located game variable
	EXALTEDMIN			= 42000,		-- minimum earned reputation for faction exalted
	EXALTEDMAX			= 42999,		-- maximum earned reputation

	-- names of option panels
	Panel1Name 			= tm_overrides['tabardmasterpanelname'] or 'Tabard Master',
	Panel2Name 			= tm_overrides['instancepanelname'] or 'Instances',
	Panel3Name 			= tm_overrides['gearpanelname'] or 'Gear Master',
	Panel4Name 			= tm_overrides['advancedpanelname'] or 'Advanced',
	Panel5Name 			= tm_overrides['aboutpanelname'] or 'About',
	
	-- font sizes for option panels
	TITLEFONT			= 'GameFontNormalLarge',
	SUBTITLEFONT		= 'GameFontHighlightSmall',
	CHECKBUTTONFONT		= 'GameFontHighlightSmall',
	MAINGROUPFONT		= 'GameFontHighlightSmall',
	MENUFONT 			= 'GameFontHighlightSmall',
	PANELTITLEFONT		= 'GameFontNormal',

	-- button sizes for option panels
	BUTTONHEIGHT  		= tm_overrides['buttonHeight']  or 24,			-- Button height and
	BUTTONWIDTH   		= tm_overrides['buttonWidth']   or 100,			-- width for most buttons
	REPBUTTONWIDTH		= 0,											-- Width of buttons to UI rep panel
	CHECKBOXSIZE  		= tm_overrides['checkboxSize']  or 24,			-- Size of all (square) checkboxes

	-- vertical spacing between option panel groups
	WIDGETVSPACE		= tm_overrides['verticalSpace'] or 40,			-- Vertical spacing between widget groups in options panels
	
	-- set minimum player levels for specific zones
	minLvlPvP			= 10,			-- Minimum level for PvP battlegrounds
	minLvlRaids			= 58,			-- Minimum level for raiding
	minLvlHome			= 90,			-- Minimum level to have a garrison / class hall
	minLvlD60			= 15,			-- Minimum level to enter classic dungeons
	minLvlD70			= 57,			-- Minimum level to enter Burning Crusade dungeons
	minLvlD80			= 68,			-- Minimum level to enter Wrath of the Lich King dungeons
	minLvlD85			= 80,			-- Minimum level to enter Cataclysm dungeons
	minLvlD90			= 85,			-- Minimum level to enter Mists of Pandaria dungeons
	minLvlD100			= 90,			-- Minimum level to enter Warlords of Draenor dungeons
	minLvlD110			= 100,			-- Minimum level to enter Legion dungeons

	-- Preferred sound files for audible warning, use with "PlaySoundFile(sound)"
	SOUND1				= "Sound\\event\\EVENT_VashjirIntro_CaptVomitVox_05.ogg",
	SOUND2				= "Sound\\Spells\\YarrrrImpact.ogg",
	
	-- Some color examples; FF0000 = Red text, 00FF00 = Green text, 0000FF = Blue text.  FFFF00 = Yellow text.
	stringRed			= '|cFFFF0000%s|r',
	stringGreen			= '|cFF00FF00%s|r',
	stringBlue			= '|cFF0000FF%s|r',
	stringYellow		= '|cFFFFFF00%s|r',
	stringCyan			= '|cFF00FFFF%s|r',
	stringPurple		= '|cFFFF00FF%s|r',
	stringWhite			= '|cFFFFFFFF%s|r',
	stringBlack			= '|cFF000000%s|r',
	
	-- Colors for the menu items
	menuColorTitle 		= tm_lang['menuColorTitle'] or '|cFFFF8000%s|r',		-- Menu titles
	menuColorGroup 		= tm_lang['menuColorGroup'] or '|cFFFFBF00%s|r',		-- Menu Groups
	menuColorFixed 		= tm_lang['menuColorFixed'] or '|cFFB94F6F%s|r',		-- Menu "presets"
	menuColorEntry 		= tm_lang['menuColorEntry'] or '|cFFC0C000%s|r',		-- Menu selectables

	-- Set zone assigned to new or undiscovered countries
	NewZone	 			= 'D110',

	-- Zone names of dungeons
	DungeonZones 		= {'D60', 'D70', 'D80', 'D85', 'D90', 'D100', 'D110'},
	
	-- Group up tabards & gearsets
	MainTabardGroup 	= {'soloTabard', 'cityTabard', 'homeTabard', 'pvpTabard', 'raidTabard'},
	DungeonTabardGroup 	= {'D60Tabard', 'D70Tabard', 'D80Tabard', 'D85Tabard', 'D90Tabard', 'D100Tabard', 'D110Tabard'},
	MainGearsetGroup 	= {'soloGear', 'cityGear', 'homeGear', 'partyGear', 'raidGear', 'pvpGear'},
	lfgGearsetGroup 	= {'lfgTANK', 'lfgHEALER', 'lfgDAMAGER', 'lfgNONE'},

	-- all the numerical options
	NumericOptions 		= {'verbose', 'tracker'},	

	-- all the true/false options
	OnOffOptions 		= {'textures', 'LFGrole', 'tabardswaps', 'wearPvP', 'gearswaps', 'quest', 'zoneSwap'},

	-- timers for blocking & waiting
	Timers 				= {'delayZoneChanges', 'blockZoneChanges', 'delayReputationChanges', 'blockReputationChanges'},

	-- path for our custom menu textures
	tm_textures			= [[Interface/AddOns/TabardMaster/Textures/theTabard.tga]],

}


-- Glue functions; generic code
function array_join(...)
-- appends a series of arrays together. Non recursive, ignores keys.  Used for creating menus
	local t = {}
	for i = 1, select('#', ...) do
		local array = select(i, ...)
		if type(array) == 'table' then
			for j = 1, #array do
				t[#t + 1] = array[j]
			end
		else
			t[#t + 1] = array
		end
	end
	return t
end
-- END of glue functions


-- Profiles & player options
function defaultProfile()
-- Generate and return a table containing the defaults for character settings
	return {
		['version'] = 0,
		['options'] = {
			['verbose'] 	= 2,
			['tracker'] 	= 1,
			['quest'] 		= true,
			['zoneSwap'] 	= false,
			['textures'] 	= true,
			['LFGrole'] 	= false,
			['wearPvP'] 	= true,
			['tabardswaps']	= true,	
			['gearswaps'] 	= true,
			['newZone'] 	= tm_constants['NewZone'],
			['minimap'] 	= {		
				['hide'] 		= false, 
				['radius'] 		= 80, 
				['minimapPos'] 	= 345,
			},
			['delayReputationChanges'] = 2,
			['blockReputationChanges'] = 10,
			['delayZoneChanges'] = 3,
			['blockZoneChanges'] = 7,
		},
		['user'] = {
			['soloTabard']	= -1,
			['cityTabard'] 	= -1,
			['pvpTabard'] 	= -1,
			['raidTabard'] 	= -1,
			['homeTabard']	= -1,
			['D60Tabard'] 	= 'auto',
			['D70Tabard'] 	= 'auto',
			['D80Tabard'] 	= 'auto',
			['D85Tabard'] 	= 'auto',
			['D90Tabard'] 	= 'auto',
			['D100Tabard'] 	= 'auto',
			['D110Tabard'] 	= 'auto',
			['soloGear'] 	= false,
			['cityGear'] 	= false,
			['partyGear'] 	= false,
			['pvpGear'] 	= false,
			['raidGear'] 	= false,
			['homeGear'] 	= false,
			['lfgTANK'] 	= false,
			['lfgHEALER'] 	= false,
			['lfgDAMAGER'] 	= false,
			['lfgNONE'] 	= false,
		},
		['category'] = {
			['solo'] 		= 'guild',
			['city'] 		= 'cities',
			['home'] 		= 'cities',
			['raid'] 		= 'cities',
			['pvp'] 		= 'arena',
			['guild'] 		= 'guild',
			['misc'] 		= 'misc',
			['D60'] 		= 'cities',
			['D70'] 		= 'D70tabards',
			['D80'] 		= 'D80tabards',
			['D85'] 		= 'D85tabards',
			['D90'] 		= 'D90tabards',
			['D100']	 	= 'D100tabards',
			['D110'] 		= 'D110tabards',
		},
	}
end
function backupProfile()
-- backs up player profile for option panel cancel functions
	tm_backup = CopyTable(tm_player)
end
function getGlobalOption(option)
	return tm_global['options'][option]
end
function setGlobalOption(option, setting)
	tm_global['options'][option] = setting
end
function getPlayerCategory(index)
	return tm_player['category'][index]
end
function getPlayerOption(option)
	return tm_player['options'][option]
end
function getPlayerSetting(index)
	return tm_player['user'][index]
end
function setPlayerCategory(index, setting)
	tm_player['category'][index] = setting
end
function setPlayerOption(option, setting)
	tm_player['options'][option] = setting
end
function setPlayerSetting(index, setting)
	tm_player['user'][index] = setting
end
-- End profile & options functions


-- Chat panel functions
function vprint(msg)
-- display some text
	if getPlayerOption('verbose') > 0 then print(msg); end
end
function dprint(...)  
-- Generate a debug message if debug mode is enabled
	if getPlayerOption('verbose') > 2 then
		local s = ''
		for i = 1, (select('#', ...)) do
			local x = (select(i, ...))
			s = strjoin(' ', s, tostring(x))
		end
		vprint('TabardMaster : ' .. s)
	end
end
-- End chat panel functions


-- Standalone functions that call the API
function getItemLink(item)
-- return iLink (colorized "itemLink" from an itemId) of an item, or nil
	if type(tonumber(item)) == 'number' then
		return (select(2, GetItemInfo(item))) or item
	end
	return tm_lang['none']
end
function TabardOMatic(itemID)
-- return our custom texture file link if one exists.  Added v123
	if type(tonumber(itemID)) == 'number' then
		local theTabard = tabardTextures[tostring(itemID)]						-- kudos, Tabard-O-Matic addon
		if getPlayerOption('textures') and theTabard then 
			return gsub(tm_constants['tm_textures'], 'theTabard', theTabard)
		end
	end
end
function getFreeBag()
-- return the id of a bag with a free slot; 0 if free slot in Backpack, nil if all bags are full
-- other "bags": 	REAGENTBANK_CONTAINER: Reagent bank (-3)
--					KEYRING_CONTAINER: Keyring and currency bag (-2)
--					BANK_CONTAINER Main storage area in the bank (-1)
--					BACKPACK_CONTAINER: Backpack (0)
--					1 through NUM_BAG_SLOTS: Bag slots (right to left in default UI)
--					NUM_BAG_SLOTS + 1 through NUM_BAG_SLOTS + NUM_BANKBAGSLOTS: Bank bag slots (left to right in default UI)
	local freeId, typeId
	for bagId = NUM_BAG_SLOTS, 0, -1 do
		freeId, typeId = GetContainerNumFreeSlots(bagId)
		if  freeId > 0 and typeId == 0 then
			return bagId
		end
	end
end
function getCurrentTabard()
-- return ItemID of currently worn tabard or 0 if no tabard is worn
	return GetInventoryItemID('player', INVSLOT_TABARD) or 0
end
function NEWgetAllTabards()
-- return array of all tabards in bag inventory
	local item, bag, slotcount, slot
	local tabards = {}
	item = getCurrentTabard()
 	if item > 0 then table.insert(tabards, item); end
	for bag = 0, NUM_BAG_SLOTS do
		slotcount = GetContainerNumSlots(bag)
		if slotcount > 0 then
			for slot = 1, slotcount do
				item = GetContainerItemID(bag, slot)
				if item and (select(9, GetItemInfo(item))) == 'INVTYPE_TABARD' then
					table.insert(tabards, tonumber(item))
				end
			end
		end
	end
	return tabards
end
function gat()
-- get all tabards - return array (unsorted) of all tabards in inventory, v120
	local item, bag, slotcount, slot
	local tabards = {}
	item = getCurrentTabard()
 	if item > 0 then 															-- include currently worn tabard
		itemName, itemLink, _, _, _, _, _, _, itemEquipLoc, itemTexture = GetItemInfo(item)
		table.insert(tabards, {
			['itemId'] 		= item,
			['itemName'] 	= itemName or '',
			['itemLink'] 	= itemLink or 'Tabard ' .. item,
			['itemIcon'] 	= itemTexture or 135026,							-- generic tabard texture iconId
		})
	end
	for bag = 0, NUM_BAG_SLOTS do												-- gather all tabards in inventory
		slotcount = GetContainerNumSlots(bag)
		if slotcount > 0 then
			for slot = 1, slotcount do
				item = GetContainerItemID(bag, slot)
				if item then
					itemName, itemLink, _, _, _, _, _, _, itemEquipLoc, itemTexture = GetItemInfo(item)
					if itemEquipLoc == 'INVTYPE_TABARD' then
						table.insert(tabards, {
							['itemId'] 		= item,
							['itemName'] 	= itemName or '',
							['itemLink'] 	= itemLink or 'Tabard ' .. item,
							['itemIcon'] 	= itemTexture or 135026,
						})
					end
				end
			end
		end
	end
	return tabards
end
function getAllGearsets()
-- return array of gearset names, icons, & equipped state, sorted by name
	local gearsets = {}
	local name, iconId, equipped
	local count = GetNumEquipmentSets()
	if count > 0 then
		for index = 1, count do
			name, iconId, _, equipped = GetEquipmentSetInfo(index)
			gearsets[index] = {
				['name'] = name,
				['iconId'] = iconId or 134400,									-- generic gearset textureID
				['equipped'] = equipped,
			}
		end
		table.sort(gearsets, function(a, b) return a['name'] < b['name']; end)
	end
	return gearsets
end
-- END of standalone API call functions


-- Options panels & support
function iofOpenPanel(panel)												-- originally added 104/105 as temporary client bug fix
-- Game client version 5.3 introduced the following quirk into the UI:
-- If InterfaceOptionsFrame_OpenToCategory(panel) is called before the addon panels list is updated after adding a new panel, 
-- the interface options frame will open to some other panel. You can work around this behavior by calling the function twice.
	if optionBugFixIOF53 then
		optionBugFixIOF53 = nil						-- Only need to do this once.
		InterfaceOptionsFrame_OpenToCategory(panel)
	end
	InterfaceOptionsFrame_OpenToCategory(panel)
end
function iofRefresh()
-- force a refresh of our options panel if shown
	if InterfaceOptionsFrame:IsShown() then
		local panelName = InterfaceOptionsFramePanelContainer.displayedPanel.name
		--print('iofRefresh: open panel is', panelName)
		for i = 1, 5 do
			if panelName == tm_constants['Panel' .. i .. 'Name'] then
				InterfaceOptionsFramePanelContainer.displayedPanel:refresh() 
			end
		end
	end
end
local tm_widgets = {
-- options panel widgets, widgets are arranged top to bottom of panel, parents containing children.
	-- start with some generic variables
	['buttonHeight']  			= tm_overrides['buttonHeight']  or 24,			-- Button height and
	['buttonWidth']   			= tm_overrides['buttonWidth']   or 100,			-- width for most buttons
	['repButtonWidth']			= 0,			--								-- Width of buttons to UI rep panel
	['chkBoxSize']  			= tm_overrides['checkboxSize']  or 24,			-- Size of all (square) checkboxes
	['widgetVspace'] 	 		= tm_overrides['verticalSpace'] or 40,			-- Vertical spacing between widget groups in options panels
	
	-- the rest is generated in individual panel creation code
	-- panel1 is main options panel code & resources
	-- panel2 is dungeon tabards panel code & resources
	-- panel3 is gearMaster panel code & resources
	-- panel4 is advanced options panel code & resources
	-- panel5 is info panel code & resources

}
function createButton(parent, xSize, ySize, xPosition, yPosition, text)
	-- create a Button xSize by ySize at location xPosition, yPosition, displays text
	local btn = CreateFrame('Button', nil, parent, 'UIPanelButtonTemplate')
	btn:SetSize(xSize, ySize)
	if xPosition then btn:SetPoint('TOPLEFT', xPosition, yPosition); end
	if text then btn:SetText(tm_lang[text]); end
	return btn
end
function createCheckButton(name, parent, xSize, ySize, xPosition, yPosition, index)
	-- create a global Checkbutton xSize by ySize at location xPosition, yPosition, named name.  modified index gets tooltip & text fields from tm_lang{}
	-- Note; InterfaceOptionsCheckButtonTemplate adds a fontinstance; the UICheckButton template does not.
	local gname = 'tmG' .. name													-- this is our widget's global name
	local tname = gname .. 'Text'												-- and it's inherited fontinstance
	local chk = CreateFrame('CheckButton', gname, parent, 'InterfaceOptionsCheckButtonTemplate')
	chk:SetSize(xSize, ySize)
	_G[tname]:SetFontObject(tm_constants['CHECKBUTTONFONT'])
	if xPosition then chk:SetPoint('TOPLEFT', xPosition, yPosition); end
	if index then
		local tip = tm_lang['chk' .. index .. 'tip'] or 'Oops!\nMissing a language file tooltip entry (' .. index .. ')'
		local i = string.find(tip, "\n")
		if i then
			chk.tooltipText = string.sub(tip, 1, i)
			chk.tooltipRequirement = string.sub(tip, i + 1)
		else
			chk.tooltipText = ' '
			chk.tooltipRequirement = tip
		end
		tip = tm_lang['chk' .. index .. 'text'] or 'oops, language file is missing an entry for ' .. index
		_G[tname]:SetText(tip)
	end
	return chk
end
function createSlider(name, parent, minimum, maximum)
	-- create a slider ...
	local gname = 'tmG' .. name
	local slider = CreateFrame('Slider', gname, parent, 'OptionsSliderTemplate')
	slider:SetOrientation("HORIZONTAL")
	slider:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	slider:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")

	slider.text = _G[gname .. 'Text']
	slider.textLow = _G[gname .. 'Low']
	slider.textHigh = _G[gname .. 'High']

	slider:SetValueStep(1)
	slider:SetMinMaxValues(minimum or 0, maximum or 30)
	--minimum, maximum = slider:GetMinMaxValues()
	slider:SetValue(minimum or 0)													-- sets current value / position of slider thumb to minimum

	return slider
end
function createTextField(parent, xSize, ySize, xPosition, yPosition)
	-- create a FontString; xSize is font to use ("GameFontNormalLarge", "GameFontHighlightSmall", etc) ySize is field height, at location xPosition, yPosition
	--local txt = parent:CreateFontString(nil, 'ARTWORK', xSize)
	local txt = parent:CreateFontString(nil, 'OVERLAY', xSize)
	if ySize then txt:SetHeight(ySize); end
	if xPosition then txt:SetPoint('TOPLEFT', xPosition, yPosition); end
	txt:SetNonSpaceWrap(false)
	txt:SetWordWrap(true)
	txt:SetIndentedWordWrap(false)
	txt:SetJustifyH('LEFT') 									-- LEFT RIGHT or CENTER (default)
	txt:SetJustifyV('MIDDLE') 									-- TOP BOTTOM or MIDDLE(default)
	return txt
end
function createFilledPanel(parent, xSize, ySize, xPosition, yPosition)
	-- create a Frame xSize by ySize at location xPosition, yPosition & fill with background color
	local panel = CreateFrame('Frame', nil, parent)
	
	if xSize then panel:SetSize(xSize, ySize); end
	if xPosition then panel:SetPoint('TOPLEFT', xPosition, yPosition); end
	panel:SetBackdrop(
		{
			bgFile = 'Interface\\Tooltips\\UI-Tooltip-Background',
			edgeFile = 'Interface\\Tooltips\\UI-Tooltip-Border',
			tile = true,
			tileSize = 16,
			edgeSize = 16,
			insets = {left = 4, right = 4, top = 4, bottom = 4}
		}
	)
	panel:SetFrameStrata('HIGH')
	panel:SetBackdropColor(0, 0, 0, 0)
	panel:SetBackdropBorderColor(1, 1, 1, 1) -- white border

	-- border is sharing same space as title field; need to correct still
	local title = panel:CreateFontString(nil, 'OVERLAY', tm_constants['PANELTITLEFONT'])
	title:SetPoint('TOPLEFT', panel, 'TOPLEFT', 8, 4)
	--title:SetFrameLevel(panel:GetFrameLevel() + 3) -- method does not exist for fontstring
	panel.title = title

	return panel
end
function createGroupWidget(parent, bXsize, bYsize, bXposn, bYposn, bText, tXsize, tYsize, tXgap)
-- creates a button widget and a text widget aligned by vertical middles
	local btn = CreateFrame('Button', nil, parent or UIParent, 'UIPanelButtonTemplate')
	btn:SetSize(bXsize or tm_constants['BUTTONWIDTH'], bYsize or tm_constants['BUTTONHEIGHT'])
	btn:SetPoint('TOPLEFT', bXposn or 0, bYposn or 0)
	if bText then btn:SetText(bText); end

	-- create a FontString; tXsize is font to use, tYsize is height, spaced tXgap right of button
	local txt 
	if parent then txt = parent:CreateFontString(nil, 'ARTWORK', tXsize or tm_constants['MAINGROUPFONT'])
	else txt = UIParent:CreateFontString(nil, 'ARTWORK', tXsize or tm_constants['MAINGROUPFONT']); end
	txt:SetHeight(tYsize or btn:GetHeight() * 1.25)		-- default text height
	txt:SetPoint('LEFT', btn, 'RIGHT', tXgap or 4, 0)
	txt:SetNonSpaceWrap(false)
	txt:SetWordWrap(true)
	txt:SetIndentedWordWrap(false)
	txt:SetJustifyH('LEFT') 									-- LEFT RIGHT or CENTER (default)
	txt:SetJustifyV('MIDDLE') 									-- TOP BOTTOM or MIDDLE(default)
	return btn, txt
end
function makeModeOption(widget1, widget2) -- added 107
	-- return 2 if widget2 exists and is checked, 1 if widget1 is checked, or 0 if neither checked.  Use widget:OnClick() 
	--	event to maintain checked status between multiple checkbox widgets.
	if widget2 and widget2:GetChecked() then return 2; end
	if widget1:GetChecked() then return 1; end
	return 0
end
-- End option panel & support code


-- Reputation functions
function resetReputationBlock()
-- Unblock UPDATE_FACTION event
	blockReputationChanges = false
	if tmInfoFrame then tmInfoFrame.RB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframeReputation'])); end
end
function getFactionNameFromFactionId(factionID)
-- returns (localized) name of a faction from it's factionId
	fID = tostring(factionID)
	if tm_reputationXRef[fID] then return tm_reputationXRef[fID].name; end
end
function getTabardFromFactionId(factionId)
-- get tabard of a faction - lookup table contains tabards only for the factions that can be championed
	fId = tostring(factionId)
	if tm_reputationXRef[fId] then return tm_reputationXRef[fId].tabard; end
end
function getFactionIdFromTabard(tabard)
-- Find the factionID a tabard champions
	return tm_tabardXRef[tostring(tabard)]
end
function getAllegianceFactionId()
-- returns 1037 (Alliance Vanguard) or 1052 (Horde Expedition) or nil, based on player's allegiance
-- also sets tm_lang['modefaction']
	tm_lang['modefaction'] = 'Select a side first'
	local playerSide = (select(1, UnitFactionGroup('player'))) or 'Neutral'
	if playerSide == 'Alliance' then 
		tm_lang['modefaction'] = tm_lang['Alliance Vanguard']
		return 1037
	elseif playerSide == 'Horde' then
		tm_lang['modefaction'] = tm_lang['Horde Expedition']
		return 1052
	end
end
function setWatchedFactionById(factionId) -- there is no SetWatchedFactionByID() API function
-- convert factionId to an index & set reputation bar to that faction, added v112, rewritten v118
	if factionId == (select(6, GetWatchedFactionInfo())) then return; end		-- faction already shown, abort
	local expandList = {}														-- expand all faction headers to find right factionID
	for factionIndex = 1, tm_constants['MAXFACTIONS'] do
		name, _, _, _, _, _, _, _, _, isCollapsed, _, isWatched, _, fId, _, _ = GetFactionInfo(factionIndex)
		if not name then break; end -- or name == FACTION_INACTIVE then break; end
		if isCollapsed then														-- expand collapsed faction headers
			expandList[#expandList + 1] = name
			ExpandFactionHeader(factionIndex)
		end
		if fId and fId == factionID then
			SetWatchedFactionIndex(factionIndex)
			break
		end
	end
	-- collapse headers we expanded, in reverse order
	for factionIndex = GetNumFactions(), 1, -1 do
		name = GetFactionInfo(factionIndex)
		if expandList[name] then CollapseFactionHeader(factionIndex); end
	end
end
function getAllReputationsByID()
-- Update reputation data for all championed factions, updated 117, 118
--print(RED_FONT_COLOR_CODE, 'TM getAllReputationsByID() called', FONT_COLOR_CODE_CLOSE)
	local name, standingId, barMin, barMax, barVal, newExalted
	for fID, v in pairs(tm_reputationXRef) do
		name, _, standingId, barMin, barMax, barVal = GetFactionInfoByID(fID) -- returns nil for enemy cities but not enemy factions
		-- Note: rep = {GetFactionInfoByID(fID)}; name = rep[1] ...  also works
		if name then 
			if not tm_reputationXRef[fID].name then tm_reputationXRef[fID].name = name; end
			tm_reputationXRef[fID].repCurrent = barVal - barMin					-- current reputation within level
			tm_reputationXRef[fID].repMax = barMax - barMin						-- maximum reputation of level
			if standingID == tm_constants['EXALTED'] and tm_reputationXRef[fID].repRank == tm_constants['REVERED'] then
				newExalted = newExalted or factionId; end						-- If multiple, only first is kept
			tm_reputationXRef[fID].repRank = standingId							-- reputation rank with this faction
		end
	end
	
	if newExalted then															-- We just leveled a reputation to exalted, so
		if getPlayerOption('tabardswaps') then
			if getPlayerOption('verbose') == 2 then								-- if allowed,
				StaticPopupDialogs['TM_POPUPBOX'] = {							-- show a popup message box,
					text = gsub(tm_lang['mbox_message0'], '%%f', getFactionNameFromFactionId(newExalted)),
					OnAccept = function()
						iofOpenPanel(tmTitle)
					end,
					timeout = 20,
					button1 = OKAY,
					button2 = CANCEL,
					whileDead = true,
					hideOnEscape = true,
				}
				StaticPopup_Show('TM_POPUPBOX')
			end
			zoneChangedEventHandler()											-- and decide on a new tabard
		end
	end
	
	local blocktimer = getPlayerOption('blockReputationChanges')
	if blocktimer > 0 then 	C_Timer.After(blocktimer, resetReputationBlock)
	else resetReputationBlock()
	end
end
function startReputationTimer()
-- Prepare to gather reputations
	--PlaySoundFile("Sound\\event\\EVENT_VashjirIntro_CaptVomitVox_05.ogg")
	if blockReputationChanges then return; end 								-- block UPDATE_FACTION event
	blockReputationChanges = true
	if tmInfoFrame then tmInfoFrame.RB:SetText(string.format(tm_constants['stringYellow'], tm_lang['infoframeReputation'])); end
	local delaytimer = getPlayerOption('delayReputationChanges')
	if delaytimer > 0 then C_Timer.After(delaytimer, getAllReputationsByID)
	else getAllReputationsByID()
	end
end
function updateReputationBar()
	-- Should reputation bar show faction reputation of a championing tabard, or be hidden ?
	if getPlayerOption('tracker') == 0 then return; end							-- abort, option is off
	local factionId = getFactionIdFromTabard(getCurrentTabard())
	if factionId then															-- show faction rep for championing tabards only
		setWatchedFactionById(factionId)
	else
		if getPlayerOption('tracker') == 2 then SetWatchedFactionIndex(0); end	-- hide the rep bar if not equipping a championing tabard
	end
end
--- End Reputation functions


-- Checks & validations
function checkIfGearset(gearSetName)
-- check if we have a valid gearset name; return gearSetName, or nil v118
	gearSetName = tostring(gearSetName)
	local gearsets = getAllGearsets()
	local count = #gearsets
	if count > 0 then
		for index = 1, count do
			if gearSetName == gearsets[index]['name'] then return gearSetName; end
		end
	end
end
function checkRangedOption(testValue, default, lowerLimit, upperLimit)
-- check an option's (numerical) setting or assign a default
	local option = tonumber(testValue) or default
	if option > upperLimit or option < lowerLimit then return default; end
	return option
end
function checkToggleOption(option, default) -- added 118
-- check and correct, if necessary, an option's boolean state
	if not option or option == 0 then return false; end
	if option == 1 or option == true then return true; end
	return default
end
function validateTabard(tabard)
-- check if "tabard" is valid via itemId or category or mode
	if type(tonumber(tabard)) == 'number' then
		tabard = tonumber(tabard)
		if tabard == -1 or tabard == 0 then										-- 'do not change tabard' (-1) & 'wear no tabard' (0)
			return tabard
		elseif tabard == -999 then												-- really old random tabard marker
			return 'random'
		end
		-- GetItemInfo() returns nothing if the client has no information about the requested item; an item request is generated 
		--	to game server but the corresponding event GET_ITEM_INFO_RECEIVED will have no data returned.  Data was originally 
		--	stored in local item cache, but this behavior was changed with release of Cataclysm expansion; the local item cache is no 
		--	longer maintained between game sessions and we have to wait for item info now.  A GetItemInfo() call is generated for 
		--	each tabard in player profile during TabardMaster's startup code, so hopefully at this point we will have valid data.
		local itemName, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(tabard)
		if itemName then
			if itemEquipLoc ~= 'INVTYPE_TABARD' then 							-- It's not a tabard!  Someone's manipulating our saved data.
				return 'auto'
			end
		end
		return tabard															-- in case we have no data, don't want to set to "auto" just yet.
	elseif type(tabard) == 'string' then
		if tabard == 'auto' or tabard == 'closest' or tabard == 'furthest' then	-- modes
			return tabard
		elseif tabard == 'faction' or tabard == 'random' then					-- more modes
			return tabard
		elseif tm_tabardGroup[tabard] then										-- catch tabard categories
			return tabard
		elseif tabard == 'randomtabard' then									-- older 'random tabard' marker
			return 'random'
		end
	end
	return 'auto'																-- fail; default to "auto"
end
function validateAllTabards()
-- validate all tabards ...
	for i, index in pairs(tm_constants['MainTabardGroup']) do
		setPlayerSetting(index, validateTabard(getPlayerSetting(index)))
	end
	for i, index in pairs(tm_constants['DungeonTabardGroup']) do 
		setPlayerSetting(index, validateTabard(getPlayerSetting(index)))
	end
end
function validateAllGearsets()
-- validate all gearsets, added 111, revised 118
	local gearsets = getAllGearsets()
	local count = #gearsets
	if count > 0 then
		for i, gearset in pairs(tm_constants['MainGearsetGroup']) do
			local gearName = getPlayerSetting(gearset)
			setPlayerSetting(gearset, false)
			for index = 1, count do
				if gearsets[index]['name'] == gearName then setPlayerSetting(gearset, gearName); break; end
			end
		end
		for i, gearset in pairs(tm_constants['lfgGearsetGroup']) do
			local gearName = getPlayerSetting(gearset)
			setPlayerSetting(gearset, false)
			for index = 1, count do
				if gearsets[index]['name'] == gearName then setPlayerSetting(gearset, gearName); break; end
			end
		end
	end
end
-- end Checks & validations


-- Tabard functions
function NEWwearTabard(tabard)
-- equip or remove tabard; if tabard = 0, remove tabard.  if tabard = nil or < 0, do not change, else equip tabard
	if not tabard then return; end
	tabard = tonumber(tabard)
	local cTabard = getCurrentTabard()	
	if tabard < 0 or tabard == cTabard then return; end							-- no need to change tabard
	if InCombatLockdown() then													-- tabard swap is prohibited
		vprint(tm_lang['lockout'])
		swapTabard = tabard	
		return
	end
	if tabard == 0 then															-- remove tabard
		local freeid = getFreeBag()
		if freeid then 
			ClearCursor()
			PickupInventoryItem(GetInventorySlotInfo('TabardSlot'))
			if freeid > 0 then
				PutItemInBag(freeid + CONTAINER_BAG_OFFSET)
			else
				PutItemInBackpack()
			end
			vprint(gsub(tm_lang['tabardremoved'], '%%t', getItemLink(cTabard)))
			ClearCursor()
		else  																	-- error; no room to stow tabard
			vprint(tm_lang['fullbags'])
		end
	else
		if GetItemCount(tabard) > 0 then 										-- make sure we have the tabard
			vprint(gsub(tm_lang['tabardchange'], '%%t', getItemLink(tabard)))
			EquipItemByName(tabard)												-- and wear it
		else -- tabard is missing; no client errors are generated, but player may want to know
			vprint(gsub(tm_lang['tabardmissing'], '%%t', getItemLink(tabard)))
		end
	end
	iofRefresh()
end
function isInTabardGroup(tabard, group)
-- return true if a tabard (itemID) is listed in a tabard group - see AllTabards.txt for default category descriptions
	if group == 'all' then return true; end										-- special case: all tabards are eligible
	if tm_tabardGroup[group] then
		for needle in string.gmatch(tm_tabardGroup[group], "%d+") do
			if tonumber(needle) == tabard then return true; end
		end
	end
end
function pickRandomTabard(tabardlist, group)
	-- randomly select a tabard from a tabard group; tabardlist is array of all tabards
	if #tabardlist == 0 then return; end
	if group == 'all' then
		return tabardlist[random(#tabardlist)] 									-- all tabards are eligible
	else
		local localTabards = {}	
		for index = 1, #tabardlist do											-- check each tabard
			if isInTabardGroup(tabardlist[index], group) then					-- against each category and
				table.insert(localTabards, tabardlist[index]) 					-- save all that match
			end
		end
		if #localTabards > 0 then												-- pick random tabard from 
			return localTabards[random(#localTabards)] 							-- selective list
		end
	end		
end
function pickClosestTabard(tabardlist, group)
	-- pick faction tabard closest to exalted from group; tabardlist is array of all tabards
	if #tabardlist == 0 then return; end
	local testValue = 0
	local bestChoice
	for index = 1, #tabardlist do
		if group == 'all' or isInTabardGroup(tabardlist[index], group) then
			fId = getFactionIdFromTabard(tabardlist[index])
			if fId then															-- limit to tabards that champion a faction
				local currentValue = tm_reputationXRef[tostring(fId)].repCurrent
					if not currentValue then return; end
				if currentValue < tm_constants['EXALTEDMIN'] and currentValue > testValue then
					testValue = currentValue
					bestChoice = tabardlist[index]
				end
			end
		end
	end
	return bestChoice
end
function pickFurthestTabard(tabardlist, group, mode)
	-- pick faction tabard furthest from exalted or with lowest reputation, from group; tabardlist is array of all tabards
	if #tabardlist == 0 then return; end
	local testValue = tm_constants['EXALTEDMIN']
	local bestChoice
	if mode == 'lowest' then testValue = tm_constants['EXALTEDMAX']; end
	for index = 1, #tabardlist do
		if group == 'all' or isInTabardGroup(tabardlist[index], group) then
			fId = getFactionIdFromTabard(tabardlist[index])
			if fId then															-- limit to tabards that champion a faction
				local currentValue = tm_reputationXRef[tostring(fId)].repCurrent
				if currentValue < testValue then
					testValue = currentValue
					bestChoice = tabardlist[index]
				end
			end
		end
	end
	return bestChoice
end
function pickBestTabard(instanceType, mode)
-- need to finish this, NEWgetAllTabards() is now gat() for development
-- instanceType can be 'raid', 'pvp', 'D80', etc
-- mode will be 'auto', 'closest', etc, or a category to pick a random tabard from

	local tabardList = NEWgetAllTabards()
	if #tabardList == 0 then return 0; end
	local tabard

	-- Championing supposedly only works in tabard level or earlier dungeons, and never classic dungeons,
	-- 	but testing revealed this is not correct.  During testing, L80 tabards did not work in L90 dungeons,
	--	nor in normal L85 dungeons - did not test in heroic L85.  L85 tabards do not work in L80 dungeons.  
	--	L85 tabards work in L90 dungeons (do not recall if marking a L90 faction for bonus rep changes this).
	-- 'faction' mode prefers Alliance Vanguard / Horde Expedition over it's child factions	

	if mode == 'auto' then														-- adjust auto mode
		mode = 'closest'
		if instanceType == 'D80' or instanceType == 'H80' then
			mode = 'faction'
		end
	end

	if mode == 'any' then
		tabard = pickRandomTabard(tabardList, 'all')
	elseif mode == 'random' then
		-- 1st choice: try to match dungeon to a championing tabard		
		if instanceType == 'D80' or instanceType == 'H80' then
			tabard = pickRandomTabard(tabardList, getPlayerCategory('D80'))
		elseif instanceType == 'D85' or instanceType == 'H85' then
			tabard = pickRandomTabard(tabardList, getPlayerCategory('D85'))
		elseif instanceType == 'D90' or instanceType == 'H90' then
			tabard = pickRandomTabard(tabardList, getPlayerCategory('D85'))
		else
		-- 2nd choice: match tabard to instance type 
			tabard = pickRandomTabard(tabardList, getPlayerCategory(instanceType))
		-- 3nd choice: pick a random city tabard
			if not tabard then tabard = pickRandomTabard(tabardList, getPlayerCategory('city')); end
		end
		-- final choice: any tabard
		if not tabard then tabard = pickRandomTabard(tabardList, 'all'); end
	elseif mode == 'faction' then
		-- 1st choice: select closest to exalted from cities group
		tabard = pickClosestTabard(tabardList, getPlayerCategory('city'))
		-- 2nd choice: select random tabard NOT in D80tabards or D85tabards groups
		if not tabard then
			local localTabards = {}
			for index = 1, #tabardList do
				if not isInTabardGroup(tabardList[index], getPlayerCategory('D80')) and not isInTabardGroup(tabardList[index], getPlayerCategory('D85')) then
					table.insert(localTabards, tabardList[index])
				end
			end
			if #localTabards > 0 then tabard = localTabards[random(#localTabards)]; end
		end
	elseif mode == 'closest' then
		-- 1st choice: try to match dungeon to a championing tabard
		if instanceType == 'D80' or instanceType == 'H80' then
			tabard = pickClosestTabard(tabardList, getPlayerCategory('D80'))
		elseif instanceType == 'D85' or instanceType == 'H85' then
			tabard = pickClosestTabard(tabardList, getPlayerCategory('D85'))
		elseif instanceType == 'D90' or instanceType == 'H90' then
			tabard = pickClosestTabard(tabardList, getPlayerCategory('D85'))
		else
		-- 2nd choice: match tabard to instance type
			tabard = pickClosestTabard(tabardList, getPlayerCategory(instanceType))
		-- 3rd choice: pick a city tabard
			if not tabard then tabard = pickClosestTabard(tabardList, getPlayerCategory('city')); end
		end
		-- final choice: any tabard
		if not tabard then tabard = pickClosestTabard(tabardList, 'all'); end
	elseif mode == 'furthest' or mode == 'lowest' then
		-- 1st choice: try to match dungeon to a championing tabard
		if instanceType == 'D80' or instanceType == 'H80' then
			tabard = pickFurthestTabard(tabardList, getPlayerCategory('D80'), mode)
		elseif instanceType == 'D85' or instanceType == 'H85' then
			tabard = pickFurthestTabard(tabardList, getPlayerCategory('D85'), mode)
		elseif instanceType == 'D90' or instanceType == 'H90' then
			tabard = pickFurthestTabard(tabardList, getPlayerCategory('D85'), mode)
		else
		-- 2nd choice: match tabard to instance type
			tabard = pickFurthestTabard(tabardList, getPlayerCategory(instanceType), mode)
		-- 3rd choice: pick a city's tabard
			if not tabard then tabard = pickFurthestTabard(tabardList, getPlayerCategory('city'), mode); end
		end
		-- final choice: any tabard
		if not tabard then tabard = pickFurthestTabard(tabardList, 'all', mode); end
	
	else -- check if custom tabard group
		if tm_lang[mode] and tm_tabardGroup[mode] and string.len(tm_tabardGroup[mode]) > 1 then
			tabard = pickRandomTabard(tabardList, mode)
		end
		
	end
	return tabard or 0
end
-- End tabard functions
--[[
	Possible enhancement: swap unused inventory tabards with ones in player's bank.
	Would have to enable this functionality only if player bank is open and there's a reason to swap.
	BANK_CONTAINER is the bank, NUM_BAG_SLOTS + 1 to NUM_BAG_SLOTS + NUM_BANKBAGSLOTS are the bank bags.
]]
function getBestTabard(mode, ...)
-- decide best tabard from several tm_tabardGroup[category] using method 'mode'
-- ASSUME tm_tabardList and tm_reputationXRef reputation tables are current
	local testMode, testValue, i, category, index, fId, currentValue, bestTabard
	if #tm_tabardList > 0 then													-- decide which mode we're working under
		if mode == 'closest' then												-- and establish individual working values
			testMode = 1
			testValue = 0														-- starting reputation value for championing
		elseif mode == 'furthest' or mode == 'lowest' then
			testMode = 2
			testValue = tm_constants['EXALTEDMIN']													-- exalted reputation level threshold
			if mode == 'lowest' then testValue = tm_constants['EXALTEDMAX']; end						-- maximum available reputation
		else
			return
		end
		for i = 1, (select('#', ...)) do
			category = (select(i, ...))											-- tabard must be in this category to be considered
			for index = 1, #tm_tabardList do
				fId = getFactionIdFromTabard(tm_tabardList[index])
				if fId then														-- limit to tabards that champion a faction
					if isInTabardGroup(tm_tabardList[index], category) then		-- and that match the category
						currentValue = tm_reputationXRef[tostring(fId)].repCurrent
						if (testMode == 1 and currentValue < tm_constants['EXALTEDMIN'] and currentValue > testValue) or (testMode == 2 and currentValue < testValue) then
							testValue = currentValue
							bestTabard = tm_tabardList[index]
						end
					end
				end
			end
		end
		return bestTabard														-- return best tabard (could be nil!)
	end
end
function getRandomTabard(...)
-- Pick a random tabard from inventory that matches one or more categories
	local localTabards = {}														-- for saving category matches
	local category, index
	local tabardCount = #tm_tabardList											-- All tabards in inventory
	if tabardCount == 0 then return; end
	for category = 1, (select('#', ...)) do										-- cut tm_tabardList down to size;
		for index = 1, tabardCount do											-- check each tabard
			if isInTabardGroup(tm_tabardList[index], (select(category, ...))) then	-- against each category and
				table.insert(localTabards, tm_tabardList[index]) 				-- save all that match
			end
		end
	end
	if #localTabards > 0 then return localTabards[random(#localTabards)]; end 	-- then pick one at random
	return
end
function vTabard(tabard)
-- decode a tabardType to visual
	if not tabard then return string.format(tm_constants['stringRed'], 'no entry'); end
	if tabard == -1 then return tm_constants['menuColorEntry'] .. tm_lang['menuActionNoChange'] .. '|r'; end
	if tabard == 0 then return tm_constants['menuColorEntry'] .. tm_lang['menuActionNoTabard'] .. '|r'; end
	return getItemLink(tabard)
end
-- end Tabards and tabard accessories


-- Gear
function NEWwearGear(gearSet)
-- Swap to new equipment set; if in combat lockdown, only weapons will swap
	local isEquipped = (select(4, GetEquipmentSetInfoByName(gearSet)))	-- used to be return #3
	if not isEquipped then
		if InCombatLockdown() then -- change weapons only for now
			swapGearSet = gearSet
			items = GetEquipmentSetItemIDs(gearSet)
			if items[INVSLOT_MAINHAND] then EquipItemByName(items[INVSLOT_MAINHAND], INVSLOT_MAINHAND); end -- main hand weapon
			if items[INVSLOT_OFFHAND] then EquipItemByName(items[INVSLOT_OFFHAND], INVSLOT_OFFHAND); end -- off hand weapon
			-- ranged weapons, should they ever return
			--if items[INVSLOT_RANGED] then EquipItemByName(items[INVSLOT_RANGED], INVSLOT_RANGED); end
			--if items[INVSLOT_AMMO] then EquipItemByName(items[INVSLOT_AMMO], INVSLOT_AMMO); end
		end
		vprint(gsub(tm_lang['gearchange'], '%%e', gearSet))
		UseEquipmentSet(gearSet)
	end
	iofRefresh()
end
-- end Gear
	

--- Mapping functions
function resetZoneChangeBlock()
-- Reset (clear) the zone change block
	blockZoneChanges = false
	if tmInfoFrame then tmInfoFrame.ZB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframeZone'])); end
end
function isInMapType(zone, mapID)
	for map in string.gmatch(tm_maps[zone], "%d+") do
		if tonumber(map) == mapID then return true; end
	end
end
function isInEnemyCity(mapID)
-- Check if player is in an enemy city; all faction cities are enemy to neutral characters
	local playerSide = (select(1, UnitFactionGroup('player'))) or 'Neutral'
	if playerSide ~= 'Alliance' then 
		if isInMapType('allianceCities', mapID) then return true; end
	elseif playerSide ~= 'Horde' then 
		if isInMapType('hordeCities', mapID) then return true; end
	end
end
function isInFriendlyCity(mapID)
-- Check if player is in a friendly or sanctuary (aka neutral) city
	local playerSide = (select(1, UnitFactionGroup('player'))) or 'Neutral'
	if isInMapType(strlower(playerSide) .. 'Cities', mapID) or isInMapType('neutralCities', mapID) then return true; end
end
function isInPvPZone(mapID) 
-- check if player is in pvp zone
	if isInMapType('PvP Zone', mapID) then return true; end
end
function isInHome() 
-- check if player is in his garrison, shipyard, or class hall
	if C_Garrison.IsOnGarrisonMap() or C_Garrison.IsOnShipyardMap() then return true; end
	-- Note: C_Garrison.IsOnShipyardMap() is not reliable in this usage; shipyards are too recessed into
	-- SMV or FW zones to generate a zone change event.  Porting in via Admiral's Compass works.
	-- C_Garrison.IsUsingPartyGarrison() determines own garrison or party leader
	-- Need to find class hall zone info & add it here.  Garrisons are actually 'party' zones in-game
	-- (for invasions?) and class halls probably should be too.
end
function getMapType(mapID)
-- find internal map type for a mapID
	for index, zones in pairs(tm_maps) do
		if isInMapType(index, mapID) then return index; end
	end
end

function NEWzoneDecoder()					-- experimental, v118
	-- returns 3 items;
	-- 1st is zonetype; 'solo', 'city', 'home', 'party', 'raid', or 'pvp'
	-- 2nd is mapType (index into tm_maps{})
	-- 3rd is instance difficultyID
	
	-- Create an info frame, added 118
	if not tmInfoFrame and not InCombatLockdown() then
		tmInfoFrame = CreateFrame("Frame", "tmZoneInfo", UIParent)
		tmInfoFrame:SetWidth(240)
		tmInfoFrame:SetHeight(70)
		tmInfoFrame:SetToplevel(1)
		tmInfoFrame:SetFrameStrata('LOW')
		tmInfoFrame:SetMovable(true)
		--tmInfoFrame:SetResizable(true)		
		tmInfoFrame:EnableMouse(true)
		if getGlobalOption('infoFrameX') then
			tmInfoFrame:SetPoint('TOPLEFT', UIParent, 'BOTTOMLEFT', getGlobalOption('infoFrameX'), getGlobalOption('infoFrameY'))
		else
			tmInfoFrame:SetPoint('CENTER', 500, -200)
		end
		tmInfoFrame:SetClampedToScreen(true)
		tmInfoFrame:RegisterForDrag("LeftButton")
		tmInfoFrame:SetScript("OnMouseDown", 
			function(_, button)
				if button == 'LeftButton' then
					tmInfoFrame:StartMoving() 
				end
				--if button == 'RightButton' then		-- resizing is disabled
				--	tmInfoFrame:StartSizing() 
				--end					
			end
		)
		tmInfoFrame:SetScript("OnMouseUp", 
			function() tmInfoFrame:StopMovingOrSizing() 
				if tmInfoFrame:GetWidth() < 240 then tmInfoFrame:SetWidth(240); end
				if tmInfoFrame:GetHeight() < 70 then tmInfoFrame:SetHeight(70); end
			end)
        tmInfoFrame:SetBackdrop({
			bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			edgeSize = 16,
			insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
		tmInfoFrame:SetBackdropColor(0, 0, 0, 0.4)
		tmInfoFrame:SetBackdropBorderColor(1, 0.8, 0, 0.8)
		tmInfoFrame.Line1 = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.Line2 = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.Line3 = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.Line4 = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.ZB = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.RB = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.CB = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.PB = tmInfoFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
		tmInfoFrame.Line1:SetPoint('TOPLEFT', 8, -10)
		tmInfoFrame.Line2:SetPoint('TOPLEFT', 8, -20)
		tmInfoFrame.Line3:SetPoint('TOPLEFT', 8, -30)
		tmInfoFrame.Line4:SetPoint('TOPLEFT', 8, -40)
		tmInfoFrame.ZB:SetPoint('TOPLEFT', 8, -50)
		tmInfoFrame.RB:SetPoint('TOPLEFT', 68, -50)
		tmInfoFrame.PB:SetPoint('TOPLEFT', 138, -50) -- offset 10 from center
		tmInfoFrame.CB:SetPoint('TOPLEFT', 188, -50)
		
		local pvpColor = 'stringGreen'
		if flagPVP then pvpColor = 'stringRed'; end
		tmInfoFrame.ZB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframeZone']))
		tmInfoFrame.RB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframeReputation']))
		tmInfoFrame.CB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframeCombat']))
		tmInfoFrame.PB:SetText(string.format(tm_constants[pvpColor], tm_lang['infoframePvP']))
		tmInfoFrame:Hide()
		if getGlobalOption('infoFrame') then tmInfoFrame:Show(); end
	end	
	-- END info frame creation code (more info frame code later)

	local zoneName, zoneType, difficultyID, _, _, _, _, instanceId, _  = GetInstanceInfo()
	-- zoneName is continent name when in instance; may be able to use that to eliminate some map referencing.	
	
	local originalZoneType, mapID = zoneType, tm_constants['ARENAMAPID']

	-- zoneType will be	"none" if the player is not in an instance, 
	--					"scenario" for scenarios, 				"party" for dungeons, 
	--					"raid" for raids, 						"arena" for arenas, and 
	--					"pvp" for battlegrounds.  Adjust accordingly.
	
	-- get mapID and localized name of zone; skip arenas as their mapIDs are all -1
	if zoneType ~= 'arena' then 
		local mapZone = GetCurrentMapZone()										-- Get map zone user is viewing
		SetMapToCurrentZone()													-- Get current mapID (instanceMapID in GetInstanceInfo() is not a mapID)
		mapID = GetCurrentMapAreaID()
		SetMapByID(mapZone)														-- restore map to what user was viewing
		zoneName = GetMapNameByID(mapID)										-- get localized map name of current zone
	end

	-- modify zoneType to be either 'solo', 'city', 'home', 'party', 'raid', or 'pvp'
	if isInHome() then zoneType = 'home'
	elseif zoneType == 'scenario' then zoneType = 'party'
	elseif zoneType == 'arena' then zoneType = 'pvp'
	elseif zoneType == 'none' then
		zoneType = 'solo'			
		if isInFriendlyCity(mapID) then zoneType = 'city'
		elseif isInEnemyCity(mapID) then zoneType = 'pvp'
		elseif isInPvPZone(mapID) then zoneType = 'pvp'
		else
			if getPlayerOption('wearPvP') and (UnitIsPVP('player') or UnitIsPVPFreeForAll('player')) then
				zoneType = 'pvp'
			end
		end
	end
	-- match mapID to an internal map type
	local mapType = getMapType(mapID) or getPlayerOption('newZone')

	-- Code for info frame used during v118 development
	if tmInfoFrame then
		--[[	from wow.gamepedia.com/DifficultyID
			1	"Normal" (Dungeons)								2	"Heroic" (Dungeons)
			3	"10 Player"										4	"25 Player"
			5	"10 Player (Heroic)"							6	"25 Player (Heroic)"
			7	"Looking For Raid" (Legacy LFRs; 				8	"Challenge Mode"
				everything prior to Siege of Orgrimmar)
			9	"40 Player"										10	nil
			11	"Heroic Scenario"								12	"Normal Scenario"
			13	nil												14	"Normal" (Raids)
			15	"Heroic" (Raids)								16	"Mythic" (Raids)
			17	"Looking For Raid"								18	"Event"
			19	"Event"											20	"Event Scenario"
			21	nil												22	nil
			23	"Mythic" (Dungeons)								24	"Timewalking"
			25	"World PVP Scenario"							26	nil
			27	nil												28	nil
			29	"PvEvP Scenario"															]]
		tmInfoFrame.Line1:SetText(string.format(tm_lang['infoframeLine1'], zoneType, GetDifficultyInfo(difficultyID) or 'Normal'))
		tmInfoFrame.Line2:SetText(string.format(tm_lang['infoframeLine2'], mapID, instanceId, mapType, zoneName or '???'))
	end
	-- END info frame code

	if UnitIsDeadOrGhost('player') then return; end								-- return nil if dead
	return zoneType, mapType, difficultyID
end

function zoneChangedEventHandler(event)
-- check we're catching ALL zone changes, think dungeons & raids are getting missed
if getPlayerOption('verbose') > 2 then UIErrorsFrame:AddMessage('TM: Zone change event', 1.0, 0.1, 0.1, 53, 10); end
-- change equipment set and tabard when zone changes
	zoneType, mapType, difficultyID = NEWzoneDecoder()
	if not zoneType then return; end
	if mapType ~= lastMapType or getPlayerOption('zoneSwap') then
		lastMapType = mapType
		local L3 = tm_lang['infoframeLine3Disabled']
		local L4 = tm_lang['infoframeLine4Disabled']
		-- pick gearset to wear
		if getPlayerOption('gearswaps') and not tm_locked then 
			local gearName
			if tmInfoFrame then tmInfoFrame.Line3:SetText(tm_lang['infoframeLine3Working']); end
			-- pick LFG role gearset if LFG queue popped
			if getPlayerOption('LFGrole') then
				for _, category in ipairs({LE_LFG_CATEGORY_LFD, LE_LFG_CATEGORY_RF, LE_LFG_CATEGORY_SCENARIO, LE_LFG_CATEGORY_LFR, LE_LFG_CATEGORY_FLEXRAID}) do
					if GetLFGMode(category) == 'lfgparty' then
						local role = UnitGroupRolesAssigned('player') or 'NONE'
						gearName = getPlayerSetting('lfg' .. role) or false
						L3 = string.format(tm_lang['infoframeLine3Changed1'], role, gearName or 'error')
						break
					end
				end
			end
			-- use zone gearset instead
			if not gearName then
				gearName = getPlayerSetting(zoneType .. 'Gear') or false
				L3 = string.format(tm_lang['infoframeLine3Changed2'], zoneType, gearName or 'not changed')
			end	
			if gearName then NEWwearGear(gearName); end
		end
	
		-- pick tabard to wear
		if getPlayerOption('tabardswaps') and not tm_locked then
			if tmInfoFrame then tmInfoFrame.Line4:SetText(tm_lang['infoframeLine4Working']); end
			local v1 = 'error'
			local v2 = 'error'
			local tabardType
			local pickType = 'D60'		
			if zoneType == 'party' then  -- convert party type to a dungeon type
				if mapType == 'Pandaria Scenarios' then pickType = 'D90'
				elseif mapType == 'Draenor Scenarios' then pickType = 'D100'
				end
				if mapType == 'X85' then
					if difficultyID == DIFFICULTY_DUNGEON_NORMAL then pickType = 'D60'
					else pickType = 'D85'; end
				elseif mapType == 'X90' then 
					if difficultyID == DIFFICULTY_DUNGEON_NORMAL then pickType = 'D60'
					else pickType = 'D90'; end
				end
				if difficultyID == DIFFICULTY_DUNGEON_NORMAL then
					if mapType == 'H80' then pickType = 'D80'
					elseif mapType == 'H85' then pickType = 'D85'
					elseif mapType == 'H90' then pickType = 'D90'
					end
				end
				tabardType = getPlayerSetting(pickType .. 'Tabard') -- tabard number, category, or mode
				v1 = string.format('%s -> %s', mapType, pickType)
			else 
				tabardType = getPlayerSetting(zoneType .. 'Tabard') -- tabard number, category, or mode
				v1 = zoneType
			end

			local tabard = -1
			if tabardType then
				if type(tonumber(tabardType)) == 'number' then
					tabard = tonumber(tabardType)
					if tabard < 0 then v2 = 'no change'
					elseif tabard == 0 then v2 = 'no tabard'
					else v2 = getItemLink(tabard); end
				elseif type(tabardType) == 'string' then 
					if zoneType == 'party' then
						tabard = pickBestTabard(pickType, tabardType)
					else
						tabard = pickBestTabard(zoneType, tabardType)
					end
					v2 = tabardType
				end
				L4 = string.format(tm_lang['infoframeLine4Changed'], v1, v2, tostring(tabard))
			end
			NEWwearTabard(tabard)
		end	
		if tmInfoFrame then tmInfoFrame.Line3:SetText(L3); end
		if tmInfoFrame then tmInfoFrame.Line4:SetText(L4); end
	end

	local blocktimer = getPlayerOption('blockZoneChanges')						-- reset zone change blocking flag
	if blocktimer > 0 then C_Timer.After(blocktimer, resetZoneChangeBlock)
	else resetZoneChangeBlock()
	end
end

function exitCombatEventHandler()
	-- finish any equipment or tabard swaps prohibited by combat lockdown; also used after QUEST_FINISHED event to return tabard to previous
	if swapGearSet then 
		UseEquipmentSet(swapGearSet)
		swapGearSet = nil
	end
	if swapTabard then
		EquipItemByName(swapTabard)
		swapTabard = nil
	end
end
function startZonechangeTimer(now)
-- check we're catching ALL zone changes, think dungeons & raids are getting missed
if getPlayerOption('verbose') > 2 then UIErrorsFrame:AddMessage('TM: Zone change delay', 1.0, 0.1, 53, 10); end
-- Prepare to start the zone change timer
	if blockZoneChanges then return; end
	blockZoneChanges = true
	if tmInfoFrame then tmInfoFrame.ZB:SetText(string.format(tm_constants['stringYellow'], tm_lang['infoframeZone'])); end
	local delaytimer = getPlayerOption('delayZoneChanges')
	if now then	delaytimer = 0; end												-- bypass timer for immediate gear / tabard change (PvP!)
	if delaytimer > 0 then C_Timer.After(delaytimer, zoneChangedEventHandler)
	else zoneChangedEventHandler()
	end
end
-- end Mapping functions


-- Option panel displays
function setDisplay(index)
-- Change a single tabard or gearset text field in our options panels
	--print('TabardMaster: setDisplay', index)
	local txt, btn, use, item, text, babelfish
	local indexIsTabard = true													-- Is index for a tabard or gearset entry?
	local isLFG = false

	-- Find text field & button references, and allowed usage of 'index'
	if 		tm_widgets['panel1'][index] then 									-- search main options panel
				txt = tm_widgets['panel1'][index]['txt']
				btn = tm_widgets['panel1'][index]['btn']
				use = tm_widgets['panel1'][index]['use']
	elseif 	tm_widgets['panel2'][index] then 									-- search dungeon tabards panel
				txt = tm_widgets['panel2'][index]['txt']
				btn = tm_widgets['panel2'][index]['btn']
				use = tm_widgets['panel2'][index]['use']
	elseif 	tm_widgets['panel3'][index] then 									-- search gearmaster panel
				indexIsTabard = false
				txt = tm_widgets['panel3'][index]['txt']
				btn = tm_widgets['panel3'][index]['btn']		
				use = tm_widgets['panel3'][index]['use']
				for i, role in pairs(tm_constants['lfgGearsetGroup']) do		-- lfg gearsets require extra step
					if index == role then isLFG = true; end
				end
	end
	if btn then btn:Disable(); end
	if not txt then dprint('setDisplay unable to locate UI references for', index or 'an invalid', 'index'); return; end

	-- capture our language file entry for index
	text = tm_lang[index] or false
	if not text then dprint('TabardMaster: setDisplay() has no index', index, 'in language file'); return; end
	
	-- get player's selection for index; tabard, tabard category, tabard function, or gearset
	item = getPlayerSetting(index)

	if indexIsTabard then
		-- create entries even if tabardswaps option is off
		if getPlayerOption('tabardswaps') and use then btn:Enable(); end	
		if use then 
			if type(tonumber(item)) == 'number' then
				item = tonumber(item)	
				if item == 0 then 												-- 0; do not wear a tabard
					babelfish = tm_lang['notabard']
				elseif item < 0 then											-- -1; don't change tabard
					babelfish = tm_lang['donotchangetabard']
				else
					babelfish = getItemLink(item)								-- item #; a specific tabard
					local factionId = getFactionIdFromTabard(item)				-- nice; 'item' is a champion tabard
					if factionId then	
						factionId = tostring(factionId)
						text = text .. "|n" .. tm_lang['reputation']			-- append reputation entry & seperate from tabard info with line break
						text = gsub(text, '%%f', tm_reputationXRef[factionId].name or 'unknown')
						text = gsub(text, '%%n', tm_reputations[tm_reputationXRef[factionId].repRank] or 0) -- add the %%c & %%m entries
						text = gsub(text, '%%c', tostring(tm_reputationXRef[factionId].repCurrent or 0))	-- and fill them
						text = gsub(text, '%%m', tostring(tm_reputationXRef[factionId].repMax or 0))
					end
				end
			else
				if tm_lang['mode' .. item] then									-- it's a mode (closest, furthest, random, etc)
					babelfish = tm_lang['mode' .. item]
				elseif tm_tabardGroup[item] then								-- wear random tabard from a standard collection
					babelfish = tm_lang[item]
				else
					for index = 0, 9 do
						if tm_lang['user' .. index] == item then				-- wear random tabard from a user collection
							babelfish = gsub(tm_lang['modecustom'], '%%e', tostring(item))
							break
						end
					end
				end
			end
		else
			babelfish = tm_lang['unavailable']
		end
	else	-- it's a gearset
		if getPlayerOption('gearswaps') and use then 
			if isLFG then														-- lfg gearset buttons require extra work
				if getPlayerOption('LFGrole') then btn:Enable(); end
			else
				btn:Enable()
			end
		end
 		-- create entries even if gearswaps option is off
		if use then
			if item and checkIfGearset(item) then
				babelfish = item
			else
				babelfish = tm_lang['donotchangegear']
			end
		else			
			babelfish = tm_lang['unavailable']
		end	
	end
	text = gsub(text, '%%t', babelfish)
	txt:SetText(text)
end
function setUsageState()
-- set true / false 'use' state of display widgets based on player level
	--tm_widgets['panel1']['soloTabard']['use'] = true							-- Main panel
	--tm_widgets['panel1']['cityTabard']['use'] = true
	tm_widgets['panel1']['homeTabard']['use'] = playerLevel >= tm_constants['minLvlHome']
	tm_widgets['panel1']['pvpTabard']['use']  = playerLevel >= tm_constants['minLvlPvP']
	tm_widgets['panel1']['raidTabard']['use'] = playerLevel >= tm_constants['minLvlRaids']
	for i, index in pairs(tm_constants['DungeonZones']) do 						-- Dungeon panel
		tm_widgets['panel2'][index .. 'Tabard']['use'] = playerLevel >= tm_constants['minLvl' .. index]
	end
	--tm_widgets['panel3']['soloGear']['use']  = true						-- Gearmaster panel
	--tm_widgets['panel3']['cityGear']['use']  = true
	tm_widgets['panel3']['homeGear']['use']  = playerLevel >= tm_constants['minLvlHome']
	tm_widgets['panel3']['partyGear']['use'] = playerLevel >= tm_constants['minLvlD60']
	tm_widgets['panel3']['raidGear']['use']  = playerLevel >= tm_constants['minLvlRaids']
	tm_widgets['panel3']['pvpGear']['use']   = playerLevel >= tm_constants['minLvlPvP']
	for i, index in pairs(tm_constants['lfgGearsetGroup']) do
		tm_widgets['panel3'][index]['use'] = playerLevel >= tm_constants['minLvlD60']
	end
end
-- end option panel displays


-- Menus.  Completely rewritten for v120
local tm_menuFill = {}															-- table for holding menu entries
local tm_menuFrame = CreateFrame('Frame', 'tm_popupMenu')						-- Will be our reusable popup menu
tm_menuFrame.displayMode = 'MENU'
tm_menuFrame.onClick = function(self, arg1, arg2, checked)						-- menu entry was selected
-- Global function; process menu clicks
	--print('TabardMaster: tm_menuFrame_onClick', arg1, arg2, 'checked: ', checked)
	if	arg1 == 'closeMenu'					then 
		CloseDropDownMenus()
	elseif 	arg1 == 'quickGear' 			then -- quick change gear
		NEWwearGear(arg2)
	elseif 	arg1 == 'quickTabard' 			then -- quick change tabard
		if type(tonumber(arg2)) == 'number' then
			NEWwearTabard(arg2)
		else
			NEWwearTabard(pickBestTabard(mapType, arg2))
		end	
	else
		if getPlayerSetting(arg1) ~= nil	then 								-- set tabards or gearsets; false is a valid state
			setPlayerSetting(arg1, arg2)
		elseif getPlayerOption(arg1) ~= nil	then								-- set options; false is a valid state
			setPlayerOption(arg1, checked)
		elseif 	arg1 == 'optionLock' 		then 								-- lock out tabard & gearset changes
			tm_locked = checked
		else
			return
		end
		iofRefresh()
	end
end
tm_menuFrame.initialize = function()
-- create menu from prefilled table
	for k, item in ipairs(tm_menuFill) do
		local info = UIDropDownMenu_CreateInfo()
		-- set default fields for info entries
		info.notCheckable = true
		info.fontObject = tm_constants['MENUFONT']
		if item.arg1 then info.arg1 = item.arg1; end
		if item.arg2 then info.arg2 = item.arg2; end
		if item.icon then info.icon = item.icon; end
		-- set display type
		if item.desc == 'title' then											-- menu descriptor
			info.text = string.format(tm_constants['menuColorTitle'], item.text)
			info.isTitle = true
		elseif item.desc == 'group' then										-- menu group header
			info.text = ''
			info.isTitle = true
			UIDropDownMenu_AddButton(info, 1)									-- add blank line first
			info.text = string.format(tm_constants['menuColorGroup'], item.text)
		elseif item.desc == 'fixed' then										-- menu selectable preset
			info.text = string.format(tm_constants['menuColorFixed'], tm_lang['menuIndent'] .. item.text)
			info.func = tm_menuFrame.onClick
		elseif item.desc == 'entry' then										-- menu selectable entry
			info.text = string.format(tm_constants['menuColorEntry'], tm_lang['menuIndent'] .. item.text)
			info.func = tm_menuFrame.onClick
		elseif item.desc == 'clear' then										-- precolored menu selectable entry
			info.text = tm_lang['menuIndent'] .. item.text
			info.func = tm_menuFrame.onClick
		elseif item.desc == 'check' then										-- menu checkable entry
			info.text = string.format(tm_constants['menuColorEntry'], item.text)
			info.func = tm_menuFrame.onClick
			info.notCheckable = false
			info.checked = item.checked or false
			info.keepShownOnClick = true
		end
		-- Add some seperation between text and icon
		if info.text and info.icon then info.text = info.text .. tm_lang['menuIndent'] .. tm_lang['menuIndent']; end

		-- Add the button entry
		UIDropDownMenu_AddButton(info, 1)
	end
	-- create 'other' group to end the menu
	local info =  {}
	info.text = ''
	info.isTitle = true
	info.notCheckable = true
	UIDropDownMenu_AddButton(info, 1)
	info.text = string.format(tm_constants['menuColorGroup'], tm_lang['menuOtherTitle'])-- 'other' group header
	UIDropDownMenu_AddButton(info, 1)
	info.isTitle = false
	info.disabled = false
	info.text = string.format(tm_constants['menuColorEntry'], tm_lang['menuIndent'] .. tm_lang['menuOtherCancel'])-- and 'Cancel' entry
	info.arg1 = 'closeMenu'
	info.func = tm_menuFrame.onClick
	UIDropDownMenu_AddButton(info, 1)
end
function submenuTabards(menuType, includeModes)
-- create action portion of a tabard menu, menuType must be 'quickTabard' for LDB menu, or dungeon level for options menu
	-- looks like:
	--	"no tabard"
	--	"don't change tabard"
	--	"random tabard"
	-- optionally, include
	--	"auto"
	--	"closest to exalted"
	--	"furthest from exalted"
	--	"Alliance Vanguard / Horde Expedition" (if D80)

	local usable = gat()
	local count = #usable
	if count < 1 then return; end					-- skip if no tabards in inventory
	local m = {}
	table.insert(m, {		-- presets group
		["desc"] = "group",
		["text"] = tm_lang['menuTabardPresets'],
	})
	table.insert(m, {
		["desc"] = "entry",
		["text"] = tm_lang['menuTabardRemove'],
		["arg1"] = menuType,
		["arg2"] = 0,
	})
	if menuType ~= 'quickTabard' then
		table.insert(m, {
			["desc"] = "entry",
			["text"] = tm_lang['menuTabardNoChange'],
			["arg1"] = menuType,
			["arg2"] = -1,
		})
	end
	table.insert(m, {
		["desc"] = "entry",
		["text"] = tm_lang['menuTabardRandom'],
		["arg1"] = menuType,
		["arg2"] = 'random',
	})
	if includeModes then
		table.insert(m, {
			["desc"] = "entry",
			["text"] = tm_lang['menuTabardAuto'],
			["arg1"] = menuType,
			["arg2"] = 'auto',
		})
		table.insert(m, {
			["desc"] = "entry",
			["text"] = tm_lang['menuTabardClosest'],
			["arg1"] = menuType,
			["arg2"] = 'closest',
		})
		table.insert(m, {
			["desc"] = "entry",
			["text"] = tm_lang['menuTabardFurthest'],
			["arg1"] = menuType,
			["arg2"] = 'furthest',
		})
		if menuType == 'D80' or zoneType == 'D80' then		-- only show in Lich King dungeons or for D80 button
			local faction = tm_lang['menuTabardFaction']
			local playerSide = (select(1, UnitFactionGroup('player'))) or 'Neutral'
			if playerSide == 'Alliance' then 
				faction = tm_lang['Alliance Vanguard']
			elseif playerSide == 'Horde' then
				faction = tm_lang['Horde Expedition']
			end				
			table.insert(m, {
				["desc"] = "entry",
				["text"] = faction,
				["arg1"] = menuType,
				["arg2"] = 'faction',
			})
		end
	end
	if menuType == 'quickTabard' then		-- individual tabards
		table.insert(m, {
			["desc"] = "group",
			["text"] = tm_lang['menuTabardQuick'],
		})
	else
		table.insert(m, {
			["desc"] = "group",
			["text"] = tm_lang['menuTabardSingle'],
		})
	end
	for index = 1, count do
		local item = usable[index]['itemId']
		local icon = TabardOMatic(item) or usable[index]['itemIcon']
		table.insert(m, {
			["desc"] = "entry",
			["text"] = usable[index]['itemLink'],
			["arg1"] = menuType,
			["arg2"] = item,
			["icon"] = icon,
		})
	end
	return m
end
function submenuEquipment(menuType)
	usable = getAllGearsets()
	count = #usable
	if count < 1 then return; end 		-- abort if no gearsets defined
	local m = {}
	if menuType == 'quickGear' then
		table.insert(m, {
			["desc"] = "group",
			["text"] = tm_lang['menuGearQuick'],
		})

--	else
--		table.insert(m, {
--			["desc"] = "group",
--			["text"] = tm_lang['menuGearSingle'],
--		})

	end 
	for index = 1, count do
		table.insert(m, {
			["desc"] = "entry",
			["text"] = usable[index]['name'],
			["arg1"] = menuType,
			["arg2"] = usable[index]['name'],
			["icon"] = usable[index]['iconId'],
		})
	end
	return m
end
function quickMenu()
	-- called from right clicking minimap button or LDB button
		m = {}
		table.insert(m, {
			["desc"] = "title",
			["text"] = tm_lang['menuOptionTitle'],
		})
		table.insert(m, {
			["desc"] = "group",
			["text"] = tm_lang['menuOptionGroup'],
		})
		table.insert(m, {		-- temporary disable
			["desc"] = "check",
			["text"] = tm_lang['menuOptionLock'],
			["arg1"] = "optionLock",
			['checked'] = tm_locked,
		})
		table.insert(m, {		-- tabard changes
			["desc"] = "check",
			["text"] = tm_lang['menuOptionSwapTabards'],
			["arg1"] = "tabardswaps",
			['checked'] = getPlayerOption('tabardswaps'),
		})
		table.insert(m, {		-- gear changes
			["desc"] = "check",
			["text"] = tm_lang['menuOptionSwapGear'],
			["arg1"] = "gearswaps",
			['checked'] = getPlayerOption('gearswaps'),
		})
		tm_menuFill = array_join(m, submenuTabards('quickTabard', true), submenuEquipment('quickGear'))
		ToggleDropDownMenu(1, nil, tm_menuFrame, 'cursor')
end
function tabardMenu(menuType)
-- called from any 'select tabard' button
		m = {}
		table.insert(m, {
			["desc"] = "title",
			["text"] = tm_lang['menuTabardSelect'],
		})
		tm_menuFill = array_join(m, submenuTabards(menuType, true))
		ToggleDropDownMenu(1, nil, tm_menuFrame, 'cursor')
end
function gearMenu(menuType)
-- called from any 'select gear set' button
		m = {}
		table.insert(m, {
			["desc"] = "title",
			["text"] = tm_lang['menuGearSelect'],
		})
		tm_menuFill = array_join(m, submenuEquipment(menuType))
		ToggleDropDownMenu(1, nil, tm_menuFrame, 'cursor')
end
-- end Menus


-- Options Panels creation
function createMainPanel()
-- Create the options panel.  Revisions v106: combined tabard & category buttons into 1, repositioned & consolidated reputation displays, all
-- 	option panel widgets now use generic creation & positioning code, options decoding functionalized, smart positioning of paired buttons & text.
	if not tm_widgets['panel1'] then	-- create the widgets !
		-- header section
		tm_widgets['panel1'] = {}
		tm_widgets['panel1']['panel'] = CreateFrame('Frame', 'TabardMasterOptions', InterfaceOptionsFramePanelContainer)
		tm_widgets['panel1']['title'] = createTextField(tm_widgets['panel1']['panel'], tm_constants['TITLEFONT'], nil, 16, -16)
		tm_widgets['panel1']['title']:SetPoint('RIGHT', tm_widgets['panel1']['panel'], -16, 0)								-- this forces a linewrap and thereby stays inbounds of optionPanel
		local fix = extraVersion or ('v' .. tmVersion)
		tm_widgets['panel1']['title']:SetText(tmTitle .. ' ' .. fix)
		tm_widgets['panel1']['subTitle'] = createTextField(tm_widgets['panel1']['panel'], tm_constants['SUBTITLEFONT'], 42, 16, -36)
		tm_widgets['panel1']['subTitle']:SetPoint('RIGHT', tm_widgets['panel1']['panel'], -16, 0)
		tm_widgets['panel1']['subTitle']:SetText(tm_lang['subtitle'])
		-- positioning reference notes:
		-- widget:SetPoint("TOPLEFT", btnCategorySolo, "TOPRIGHT", 20, 0)
		-- widget:SetPoint(local anchor point, relative, relative reference point, x offset, y offset)
		-- 	x, y offsets:   left/right, up/down  (negative values move left, or down)
	
		-- added 109; on/off checkboxs for tabard and gear swaps
		tm_widgets['panel1']['upperFill'] = {}
		tm_widgets['panel1']['upperFill']['panel'] = createFilledPanel(tm_widgets['panel1']['panel'], 16, tm_widgets['widgetVspace'], 16, -84) -- width is updated in refresh routine
		tm_widgets['panel1']['upperFill']['chk'] = {}
		tm_widgets['panel1']['upperFill']['chk']['tabardSwaps'] = createCheckButton('chkTabardSwaps', tm_widgets['panel1']['upperFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], 8, (tm_widgets['chkBoxSize'] - tm_widgets['widgetVspace']) / 2, 'tabardenable')
		tm_widgets['panel1']['upperFill']['chk']['tabardSwaps']:SetScript('OnClick', function()								-- checked state and position
			setPlayerOption('tabardswaps', tm_widgets['panel1']['upperFill']['chk']['tabardSwaps']:GetChecked())				-- are set in refresh event
			tm_widgets['panel1']['panel'].refresh()								-- run each panel's refresh routine
			tm_widgets['panel2']['panel']:refresh()							-- to set each panel's buttons state
--			tm_widgets['panel3']['panel']:refresh()
		end)
		tm_widgets['panel1']['upperFill']['chk']['gearSwaps'] = createCheckButton('chkGearsetSwaps', tm_widgets['panel1']['upperFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], 8, (tm_widgets['chkBoxSize'] - tm_widgets['widgetVspace']) / 2, 'gearenable')
		tm_widgets['panel1']['upperFill']['chk']['gearSwaps']:SetScript('OnClick', function()
			setPlayerOption('gearswaps', tm_widgets['panel1']['upperFill']['chk']['gearSwaps']:GetChecked())
--			tm_widgets['panel1']['panel'].refresh()
--			tm_widgets['panel2']['panel']:refresh()
			tm_widgets['panel3']['panel']:refresh()
		end)
		tm_widgets['panel1']['upperFill']['chk']['lockedOut'] = createCheckButton('chkLockedOut', tm_widgets['panel1']['upperFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], 8, (tm_widgets['chkBoxSize'] - tm_widgets['widgetVspace']) / 2, 'sessionLock')
		tm_widgets['panel1']['upperFill']['chk']['lockedOut']:SetScript('OnClick', function()								-- checked state and position
			tm_locked = tm_widgets['panel1']['upperFill']['chk']['lockedOut']:GetChecked()								-- are set in refresh event
		end)
		
		-- Each tabard group consists of a button to change tabard, and a multi line text field that describes a tabard group and 
		-- that group's selected tabard, plus a faction reputation when wearing a champion tabard.  This same pattern is duplicated 
		-- in the instance and gearmaster option panels, although the gearmaster text lines are always single line.
		-- The text line widths are updated in each panel's refresh event.

		-- ref: createGroupWidget(parent, bXsize, bYSize, bXPosn, bYPosn, bText, tXsize, tYsize, tXgap)
		for i, index in pairs(tm_constants['MainTabardGroup']) do 
			tm_widgets['panel1'][index] = {}
			tm_widgets['panel1'][index]['btn'], tm_widgets['panel1'][index]['txt'] = 
				createGroupWidget(tm_widgets['panel1']['panel'], false, false, 16, -84 - ((tm_widgets['widgetVspace'] + 4) * i), tm_lang['picktabardbutton'], tm_constants['MAINGROUPFONT'], nil, 12)
			tm_widgets['panel1'][index]['btn']:SetScript('OnClick', function() tabardMenu(index); end)
			tm_widgets['panel1'][index]['use'] = true
		end		
		
		-- Now the checkbox options; positioning and sizing are updated in panel refresh event
		tm_widgets['panel1']['lowerFill'] = {}
		tm_widgets['panel1']['lowerFill']['panel'] = createFilledPanel(tm_widgets['panel1']['panel'], 16, 200, 16, -340)	-- added 104/105
		-- Left side entries
		-- Verbose mode checkboxes (2)
		tm_widgets['panel1']['lowerFill']['chk'] = {}
		tm_widgets['panel1']['lowerFill']['chk']['verbose'] = createCheckButton('chkVerbose', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'verbose1')
		tm_widgets['panel1']['lowerFill']['chk']['verbose2'] = createCheckButton('chkVerbose2', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'verbose2')
		tm_widgets['panel1']['lowerFill']['chk']['verbose']:SetScript('OnClick', function()	-- keep the 2 verbose checkboxes in sync, #1
			if not tm_widgets['panel1']['lowerFill']['chk']['verbose']:GetChecked() then tm_widgets['panel1']['lowerFill']['chk']['verbose2']:SetChecked(false); end
			setPlayerOption('verbose', makeModeOption(tm_widgets['panel1']['lowerFill']['chk']['verbose'], tm_widgets['panel1']['lowerFill']['chk']['verbose2']))
		end)
		tm_widgets['panel1']['lowerFill']['chk']['verbose2']:SetScript('OnClick', function()	-- keep the 2 verbose checkboxes in sync, #2
			if tm_widgets['panel1']['lowerFill']['chk']['verbose2']:GetChecked() then tm_widgets['panel1']['lowerFill']['chk']['verbose1']:SetChecked(true); end
			setPlayerOption('verbose', makeModeOption(tm_widgets['panel1']['lowerFill']['chk']['verbose'], tm_widgets['panel1']['lowerFill']['chk']['verbose2']))
		end)
		-- the 'Wear guild tabard when turning in quests' checkbox
		tm_widgets['panel1']['lowerFill']['chk']['quest'] = createCheckButton('chkQuest', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'quest')
		tm_widgets['panel1']['lowerFill']['chk']['quest']:SetScript('OnClick', function()		-- we want immediate feedback of minimap checkbutton
			setPlayerOption('quest', tm_widgets['panel1']['lowerFill']['chk']['quest']:GetChecked())
		end)
		-- "Display a Minimap button"
		tm_widgets['panel1']['lowerFill']['chk']['minimap'] = createCheckButton('chkMinimap', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'minimap')
		tm_widgets['panel1']['lowerFill']['chk']['minimap']:SetScript('OnClick', function()	-- we want immediate feedback of minimap checkbutton
			mmIconBuffer['hide'] = not(tm_widgets['panel1']['lowerFill']['chk']['minimap']:GetChecked())
			tm_player['options']['minimap']['hide'] = mmIconBuffer['hide']
			mmIcon:Refresh(tmTitle)
		end)
		-- Use custom textures in menus (Tabard-O-Matic)
		tm_widgets['panel1']['lowerFill']['chk']['textures'] = createCheckButton('chkTextures', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'texture')
		tm_widgets['panel1']['lowerFill']['chk']['textures']:SetScript('OnClick', function()	-- we want immediate feedback of textures checkbutton
			setPlayerOption('textures', tm_widgets['panel1']['lowerFill']['chk']['textures']:GetChecked())
		end)
		-- Right side entries
		-- Swap currently watched faction when tabard changes; 2 checkboxes
		tm_widgets['panel1']['lowerFill']['chk']['tracker'] = createCheckButton('chkTracker', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'tracker1')
		tm_widgets['panel1']['lowerFill']['chk']['tracker2'] = createCheckButton('chkTracker2', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'tracker2')
		tm_widgets['panel1']['lowerFill']['chk']['tracker']:SetScript('OnClick', function()	-- keep the 2 reputation checkboxes in sync, #1
			if not tm_widgets['panel1']['lowerFill']['chk']['tracker']:GetChecked() then tm_widgets['panel1']['lowerFill']['chk']['tracker2']:SetChecked(false); end
			setPlayerOption('tracker', makeModeOption(tm_widgets['panel1']['lowerFill']['chk']['tracker'], tm_widgets['panel1']['lowerFill']['chk']['tracker2']))
		end)
		tm_widgets['panel1']['lowerFill']['chk']['tracker2']:SetScript('OnClick', function()	-- keep the 2 reputation checkboxes in sync, #2
			if tm_widgets['panel1']['lowerFill']['chk']['tracker2']:GetChecked() then tm_widgets['panel1']['lowerFill']['chk']['tracker']:SetChecked(true); end
			setPlayerOption('tracker', makeModeOption(tm_widgets['panel1']['lowerFill']['chk']['tracker'], tm_widgets['panel1']['lowerFill']['chk']['tracker2']))
		end)
		-- Prevent tabard swaps during normal zone changes
		tm_widgets['panel1']['lowerFill']['chk']['zoneSwap'] = createCheckButton('chkZoneSwap', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'zone')
		tm_widgets['panel1']['lowerFill']['chk']['zoneSwap']:SetScript('OnClick', function()	-- we want immediate feedback of minimap checkbutton
			setPlayerOption('zoneSwap', tm_widgets['panel1']['lowerFill']['chk']['zoneSwap']:GetChecked())
		end)
		-- Treat PvE zones as PvP - added 108.  Revised 118: use PvP if flagged PvP
		tm_widgets['panel1']['lowerFill']['chk']['wearPvP'] = createCheckButton('chkWearPvP', tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], nil, nil, 'wearpvp')
		tm_widgets['panel1']['lowerFill']['chk']['wearPvP']:SetScript('OnClick', function()	-- we want immediate feedback of minimap checkbutton
			setPlayerOption('wearPvP', tm_widgets['panel1']['lowerFill']['chk']['wearPvP']:GetChecked())
		end)

		-- "show the UI reputation panel" button
		tm_widgets['panel1']['btnReputation'] = createButton(tm_widgets['panel1']['lowerFill']['panel'], tm_widgets['buttonWidth'], tm_widgets['buttonHeight'], nil, nil, 'reputationbutton')
		tm_widgets['panel1']['btnReputation']:SetScript('OnClick', function() ToggleCharacter('ReputationFrame'); end)

		-- A status line at bottom
		tm_widgets['panel1']['status'] = createTextField(tm_widgets['panel1']['panel'], 'GameFontHighlightSmall', 18, 16, -546) -- was -542
		tm_widgets['panel1']['status']:SetPoint('RIGHT', tm_widgets['panel1']['panel'], -16, 0)

		tm_widgets['panel1']['panel']:SetScript('OnShow', function()
			--print('optionPanel OnShow')
			backupProfile()	-- note; this is repeated in each panel's OnShow event, as panels can be opened directly
		end)

		tm_widgets['panel1']['panel'].refresh = function(self)					-- runs when Options frame calls its "OnShow" and "default" functions
			--print('optionPanel:refresh()')
			-- Note; each child panel also has a refresh() routine, and they're all called sequentially when parent one fires
			-- Nominal options panel size is 622x568; this can be changed so we have to reposition and constrain our widgets.  Has not been well tested.

			-- Set width of full width panel widgets
			local w = math.floor(InterfaceOptionsFramePanelContainer:GetWidth())
			local widgetWidth = tm_widgets['panel1']['upperFill']['panel']:GetWidth() or -1							-- determine if we need to (re)size widgets
			if widgetWidth ~= (w - 32) then
				tm_widgets['panel1']['upperFill']['panel']:SetWidth(w - 32)		-- set width of option panel's frames
				tm_widgets['panel1']['lowerFill']['panel']:SetWidth(w - 32)

				-- set width of upperFill widgets
				local splitLine = math.floor((w - 32) / 3)
				widgetWidth = splitLine - 64
				_G[tm_widgets['panel1']['upperFill']['chk']['tabardSwaps']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['upperFill']['chk']['gearSwaps']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['upperFill']['chk']['lockedOut']:GetName() .. 'Text']:SetWidth(widgetWidth)
				-- position upperFill checkbox widgets
				tm_widgets['panel1']['upperFill']['chk']['tabardSwaps']:SetPoint('TOPLEFT', 8, -8)
				tm_widgets['panel1']['upperFill']['chk']['gearSwaps']:SetPoint('TOPLEFT', splitLine, -8)
				tm_widgets['panel1']['upperFill']['chk']['lockedOut']:SetPoint('TOPLEFT', splitLine * 2, -8)
				
				-- set width of tabard groups text field
				widgetWidth = w - 48											-- set width of upper section's widgets
				for i, group in pairs(tm_constants['MainTabardGroup']) do 
					tm_widgets['panel1'][group]['txt']:SetWidth(widgetWidth)
				end

				splitLine = math.floor(w / 2) 		 							-- calculate horizontal center of optionPanel
				widgetWidth = splitLine - 76  									-- Reset widgetWidth for options text fields
				-- set width of lowerFill widgets
				_G[tm_widgets['panel1']['lowerFill']['chk']['verbose']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['verbose2']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['quest']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['minimap']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['textures']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['tracker']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['tracker2']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['zoneSwap']:GetName() .. 'Text']:SetWidth(widgetWidth)
				_G[tm_widgets['panel1']['lowerFill']['chk']['wearPvP']:GetName() .. 'Text']:SetWidth(widgetWidth)
				-- position lower fill panel widgets, left side
				tm_widgets['panel1']['lowerFill']['chk']['verbose']:SetPoint('TOPLEFT', 8, -8)																	-- Position the verbose checkbox,
				tm_widgets['panel1']['lowerFill']['chk']['verbose2']:SetPoint('TOPLEFT', 8 + tm_widgets['chkBoxSize'], -8 - tm_widgets['widgetVspace'])			-- indent 2nd row "sub-option"
				tm_widgets['panel1']['lowerFill']['chk']['quest']:SetPoint('TOPLEFT', 8, -8 - (tm_widgets['widgetVspace'] * 2))									-- Guild tabard worn at quest turn-in
				tm_widgets['panel1']['lowerFill']['chk']['minimap']:SetPoint('TOPLEFT', 8, -8 - (tm_widgets['widgetVspace'] * 3))									-- show a Minimap icon
				tm_widgets['panel1']['lowerFill']['chk']['textures']:SetPoint('TOPLEFT', 8, -8 - (tm_widgets['widgetVspace'] * 4))								-- Custom textures in menus
				-- position lower fill panel widgets, right side
				tm_widgets['panel1']['lowerFill']['chk']['tracker']:SetPoint('TOPLEFT', splitLine, -8)															-- Reputation tracking bar
				tm_widgets['panel1']['lowerFill']['chk']['tracker2']:SetPoint('TOPLEFT', splitLine + tm_widgets['chkBoxSize'], -8 - tm_widgets['widgetVspace'])	-- indent 2nd row "sub-option"
				tm_widgets['panel1']['lowerFill']['chk']['zoneSwap']:SetPoint('TOPLEFT', splitLine, -8 - (tm_widgets['widgetVspace'] * 2))						-- swap tabard at every zone change
				tm_widgets['panel1']['lowerFill']['chk']['wearPvP']:SetPoint('TOPLEFT', splitLine, -8 - (tm_widgets['widgetVspace'] * 3))							-- open zones treated as PVP zones (108)
				-- position the UI reputation button
				tm_widgets['panel1']['btnReputation']:SetPoint('TOPLEFT', splitLine + 16, -8 - (tm_widgets['widgetVspace'] * 4))									-- 'open UI reputations' button
				tm_widgets['panel1']['btnReputation']:SetWidth(widgetWidth - 24)
				tm_widgets['repButtonWidth'] = widgetWidth - 24					-- save for other reputation button
			end
			-- set checked state of option checkbuttons
			tm_widgets['panel1']['upperFill']['chk']['tabardSwaps']:SetChecked(getPlayerOption('tabardswaps'))
			tm_widgets['panel1']['upperFill']['chk']['gearSwaps']:SetChecked(getPlayerOption('gearswaps'))
			tm_widgets['panel1']['upperFill']['chk']['lockedOut']:SetChecked(tm_locked)
			tm_widgets['panel1']['lowerFill']['chk']['verbose']:SetChecked(getPlayerOption('verbose') > 0)
			tm_widgets['panel1']['lowerFill']['chk']['verbose2']:SetChecked(getPlayerOption('verbose') > 1)
			tm_widgets['panel1']['lowerFill']['chk']['quest']:SetChecked(getPlayerOption('quest'))
			tm_widgets['panel1']['lowerFill']['chk']['minimap']:SetChecked(not(mmIconBuffer['hide']))
			tm_widgets['panel1']['lowerFill']['chk']['textures']:SetChecked(getPlayerOption('textures'))
			tm_widgets['panel1']['lowerFill']['chk']['tracker']:SetChecked(getPlayerOption('tracker') > 0)
			tm_widgets['panel1']['lowerFill']['chk']['tracker2']:SetChecked(getPlayerOption('tracker') > 1)
			tm_widgets['panel1']['lowerFill']['chk']['zoneSwap']:SetChecked(getPlayerOption('zoneSwap'))
			tm_widgets['panel1']['lowerFill']['chk']['wearPvP']:SetChecked(getPlayerOption('wearPvP'))
			-- Set displays for this panel
			for i, group in pairs(tm_constants['MainTabardGroup']) do
				setDisplay(group)
			end
		end

		-- Some UI button click code.  Note: the UI's 'okay' and 'cancel' buttons call all option panels' okay and cancel routines; 'default' button has no equivalent
		tm_widgets['panel1']['panel'].okay = function()						-- set our saved variables from current checkboxes
			--print('optionPanel okay')
			updateReputationBar()
		end

		tm_widgets['panel1']['panel'].cancel = function()
		-- revert panel variables to backup copy
			--print('optionPanel cancel')
			for i, index in pairs(tm_constants['MainTabardGroup']) do 
				setPlayerSetting(index, tm_backup['user'][index])
			end			

			setPlayerOption('tabardswaps', 	tm_backup['options']['tabardswaps'])
			setPlayerOption('gearswaps', 	tm_backup['options']['gearswaps'])
			setPlayerOption('verbose', 		tm_backup['options']['verbose'])
			setPlayerOption('tracker', 		tm_backup['options']['tracker'])
			setPlayerOption('textures', 	tm_backup['options']['textures'])
			setPlayerOption('wearPvP', 		tm_backup['options']['wearPvP'])
			setPlayerOption('quest', 		tm_backup['options']['quest'])
			setPlayerOption('zoneSwap', 	tm_backup['options']['zoneSwap'])
			setPlayerOption('newZone', 		tm_backup['options']['newZone'])
			tm_player['options']['minimap'] = CopyTable(tm_backup['options']['minimap'])
		end

		tm_widgets['panel1']['panel'].default = function()
			-- set panel's options to default values; other panels responsible for their own values
			--print('optionPanel default')
			default_profile = defaultProfile()

			for i, index in pairs(tm_constants['MainTabardGroup']) do 
				setPlayerSetting(index, default_profile['user'][index])
			end			

			setPlayerOption('tabardswaps', 	default_profile['options']['tabardswaps'])
			setPlayerOption('gearswaps', 	default_profile['options']['gearswaps'])
			setPlayerOption('verbose', 		default_profile['options']['verbose'])
			setPlayerOption('tracker', 		default_profile['options']['tracker'])
			setPlayerOption('textures', 	default_profile['options']['textures'])
			setPlayerOption('wearPvP', 		default_profile['options']['wearPvP'])
			setPlayerOption('quest', 		default_profile['options']['quest'])
			setPlayerOption('zoneSwap', 	default_profile['options']['zoneSwap'])
			setPlayerOption('newZone', 		default_profile['options']['newZone'])
			tm_player['options']['minimap'] = CopyTable(default_profile['options']['minimap'])
			tm_player['options']['debug'] = nil		
			--tm_widgets['panel1']['panel']:refresh()
		end

		tm_widgets['panel1']['panel'].name = tm_constants['Panel1Name']			-- add our panel to the UI
		InterfaceOptions_AddCategory(tm_widgets['panel1']['panel'])
	end

	-- May need to trap any resize of InterfaceOptionsFrame; not sure.  Left disabled for now; may also need blocker variable.  Scaling, however, works fine.
--	InterfaceOptionsFrame:HookScript("OnSizeChanged", function() optionPanelInfo['Width'] = 0; end)
end
function createInstancePanel()
-- Now add the Instance Panel for tabards
	if not tm_widgets['panel2'] then
		tm_widgets['panel2'] = {}
		tm_widgets['panel2']['panel'] = CreateFrame('Frame', 'TabardMasterDungeon', InterfaceOptionsFramePanelContainer)
		tm_widgets['panel2']['title'] = createTextField(tm_widgets['panel2']['panel'], tm_constants['TITLEFONT'], nil, 16, -16)
		tm_widgets['panel2']['title']:SetPoint('RIGHT', tm_widgets['panel2']['panel'], -16, 0)						-- setting right (and thereby width) forces a linewrap if necessary and keeps constrained within optionpanel
		tm_widgets['panel2']['title']:SetText(tmTitle .. ' - ' .. tm_lang['instancepaneltitle'])
		tm_widgets['panel2']['subTitle'] = createTextField(tm_widgets['panel2']['panel'],  tm_constants['SUBTITLEFONT'], 42, 16, -36)
		tm_widgets['panel2']['subTitle']:SetPoint('RIGHT', tm_widgets['panel2']['panel'], -16, 0)
		tm_widgets['panel2']['subTitle']:SetText(tm_lang['instancepanelsubtitle'])

		for i, index in pairs(tm_constants['DungeonTabardGroup']) do 
			tm_widgets['panel2'][index] = {}
			tm_widgets['panel2'][index]['btn'], tm_widgets['panel2'][index]['txt'] = 
				createGroupWidget(tm_widgets['panel2']['panel'], false, false, 16, -58 - ((tm_widgets['widgetVspace'] + 8) * i), tm_lang['picktabardbutton'], tm_constants['MAINGROUPFONT'], nil, 12)
			tm_widgets['panel2'][index]['btn']:SetScript('OnClick', function() tabardMenu(index); end)
			tm_widgets['panel2'][index]['use'] = true
		end

		tm_widgets['panel2']['btnReputation'] = createButton(tm_widgets['panel2']['panel'], tm_widgets['buttonWidth'], tm_widgets['buttonHeight'])		-- show the UI reputation panel
		tm_widgets['panel2']['btnReputation']:SetScript('OnClick', function() ToggleCharacter('ReputationFrame'); end)
		
		tm_widgets['panel2']['panel']:SetScript('OnShow', function()
			--print('instancePanel OnShow')
			local splitLine = math.floor(InterfaceOptionsFramePanelContainer:GetWidth() / 2)
			tm_widgets['panel2']['btnReputation']:SetPoint('TOPLEFT', tm_widgets['panel2']['panel'], 'BOTTOMLEFT', splitLine + 32, 50) -- formula is btnReputation1:GetLeft() + tm_widgets['panel1']['lowerFill']['panel']:GetLeft(), or 16 + 16, or just 32
			tm_widgets['panel2']['btnReputation']:SetText(tm_lang['reputationbutton'])
			backupProfile()
		end)

		tm_widgets['panel2']['panel'].refresh = function()						-- runs at Options frame "OnShow" and "default" events
			--print('instancePanel refresh()')
			local w = math.floor(InterfaceOptionsFramePanelContainer:GetWidth())
			local widgetWidth = w - 124											-- width of instance text fields
			if widgetWidth ~= tm_widgets['panel2']['D60Tabard']['txt']:GetWidth() then	-- Resize widgets if container width has changed
				for x, dungeon in pairs(tm_constants['DungeonTabardGroup']) do
					tm_widgets['panel2'][dungeon]['txt']:SetWidth(widgetWidth)
				end				
				tm_widgets['panel2']['btnReputation']:SetWidth(tm_widgets['repButtonWidth'])
			end	
			-- set displays for this panel
			for i, group in pairs(tm_constants['DungeonTabardGroup']) do
				setDisplay(group)
			end
		end

--		tm_widgets['panel2']['panel'].okay = function(); end
		tm_widgets['panel2']['panel'].cancel = function()
			--print('instancePanel:cancel()')
			for i, index in pairs(tm_constants['DungeonTabardGroup']) do 
				setPlayerSetting(index, tm_backup['user'][index])
			end			
		end
		
		tm_widgets['panel2']['panel'].default = function()
			--print('instancePanel:default()')
			default_profile = defaultProfile()
			for i, index in pairs(tm_constants['DungeonTabardGroup']) do 
				setPlayerSetting(index, default_profile['user'][index])
			end			
		end

		-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category) and add it
		tm_widgets['panel2']['panel'].parent = tm_constants['Panel1Name']
		tm_widgets['panel2']['panel'].name = tm_constants['Panel2Name']
		InterfaceOptions_AddCategory(tm_widgets['panel2']['panel'])
	end
end
function createGearMasterPanel()
-- The "GearMaster" panel
	if not tm_widgets['panel3'] then
		tm_widgets['panel3'] = {}
		tm_widgets['panel3']['panel'] = CreateFrame('Frame', 'TabardMasterGear', InterfaceOptionsFramePanelContainer)
		tm_widgets['panel3']['title'] = createTextField(tm_widgets['panel3']['panel'], tm_constants['TITLEFONT'], nil, 16, -16)
		tm_widgets['panel3']['title']:SetText(tmTitle .. ' - ' .. tm_lang['gearpaneltitle'])
		tm_widgets['panel3']['subTitle'] = createTextField(tm_widgets['panel3']['panel'], tm_constants['SUBTITLEFONT'], 42, 16, -28)
		tm_widgets['panel3']['subTitle']:SetPoint('RIGHT', tm_widgets['panel3']['panel'], -16, 0)
		tm_widgets['panel3']['subTitle']:SetText(tm_lang['gearpanelsubtitle'])

		for i, index in pairs(tm_constants['MainGearsetGroup']) do 
			tm_widgets['panel3'][index] = {}
			tm_widgets['panel3'][index]['btn'], tm_widgets['panel3'][index]['txt'] = 
				createGroupWidget(tm_widgets['panel3']['panel'], false, false, 16, -31 - ((tm_widgets['widgetVspace'] + 0) * i), tm_lang['instancebutton'], tm_constants['MAINGROUPFONT'], nil, 12)
			tm_widgets['panel3'][index]['btn']:SetScript('OnClick', function() gearMenu(index); end)
			tm_widgets['panel3'][index]['use'] = true
		end
		
		----- 104/105 changes; added LFG role option & gearsets
		tm_widgets['panel3']['LFGfill'] = {}
		tm_widgets['panel3']['LFGfill']['panel'] = createFilledPanel(tm_widgets['panel3']['panel'], 591, 240, 16, -320)  -- NOTE: optionsPanel filledPanel is 591 * 200
		tm_widgets['panel3']['LFGfill']['txt'] = {}
		tm_widgets['panel3']['LFGfill']['txt']['LFGenable'] = createTextField(tm_widgets['panel3']['LFGfill']['panel'], tm_constants['MAINGROUPFONT'], 36, 8, -8) -- -8 was -16
		tm_widgets['panel3']['LFGfill']['txt']['LFGenable']:SetPoint('RIGHT', tm_widgets['panel3']['LFGfill']['panel'], -8, 0)
		tm_widgets['panel3']['LFGfill']['txt']['LFGenable']:SetText(tm_lang['lfgInfo'])

		tm_widgets['panel3']['LFGfill']['chk'] = {}
		tm_widgets['panel3']['LFGfill']['chk']['LFGenable'] = createCheckButton('chkLFGenable', tm_widgets['panel3']['LFGfill']['panel'], tm_widgets['chkBoxSize'], tm_widgets['chkBoxSize'], 8, 0 - tm_widgets['widgetVspace'], 'LFGrole') -- 0 was -16
		tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:SetScript('OnClick', function()
			setPlayerOption('LFGrole', tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:GetChecked())
			tm_widgets['panel3']['panel'].refresh()
		end)

		for i, index in pairs(tm_constants['lfgGearsetGroup']) do 
			tm_widgets['panel3'][index] = {}
			tm_widgets['panel3'][index]['btn'], tm_widgets['panel3'][index]['txt'] = 
				createGroupWidget(tm_widgets['panel3']['LFGfill']['panel'], false, false, 8, 4 - ((tm_widgets['widgetVspace'] + 0) * (i + 1)), tm_lang['instancebutton'], tm_constants['MAINGROUPFONT'], nil, 12)
			tm_widgets['panel3'][index]['btn']:SetScript('OnClick', function() gearMenu(index); end)
			tm_widgets['panel3'][index]['use'] = true
		end
		
		tm_widgets['panel3']['panel']:SetScript('OnShow', function()
			--print('gearPanel OnShow')
			backupProfile()
		end)

		tm_widgets['panel3']['panel'].refresh = function(self) 					-- populate, enable, & position panel's widgets
			--print('gearPanel:refresh()')
			local w = math.floor(InterfaceOptionsFramePanelContainer:GetWidth() + .5)
			local widgetWidth = w - 124											-- width of group type text fields
			if widgetWidth ~= tm_widgets['panel3']['soloGear']['txt']:GetWidth() then	-- Resize displays if container width has changed
				for i, index in pairs(tm_constants['MainGearsetGroup']) do 
					tm_widgets['panel3'][index]['txt']:SetWidth(widgetWidth)
				end
				widgetWidth = w - 116											-- width of LFG text fields
				tm_widgets['panel3']['LFGfill']['panel']:SetWidth(w - 32)		-- 16 pixel left / right margins
				_G[tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:GetName() .. 'Text']:SetWidth(widgetWidth)
				for i, index in pairs(tm_constants['lfgGearsetGroup']) do
					tm_widgets['panel3'][index]['txt']:SetWidth(widgetWidth)
				end
			end	
			-- enable LFG role checkbox & set checked state
			tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:Disable()
			tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:SetChecked(false)
			if playerLevel >= tm_constants['minLvlD60'] and getPlayerOption('gearswaps') then
				tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:Enable()
				tm_widgets['panel3']['LFGfill']['chk']['LFGenable']:SetChecked(getPlayerOption('LFGrole'))
			end
			-- set displays (2 sets) for this panel
			for i, group in pairs(tm_constants['MainGearsetGroup']) do
				setDisplay(group)
			end
			for i, group in pairs(tm_constants['lfgGearsetGroup']) do
				setDisplay(group)
			end
		end

		tm_widgets['panel3']['panel'].okay = function(self)
			--print('gearpanel okay')
		end

		tm_widgets['panel3']['panel'].cancel = function(self)
			--print('gearpanel cancel')
			for i, index in pairs(tm_constants['MainGearsetGroup']) do 
				setPlayerSetting(index, tm_backup['user'][index])
			end
			setPlayerOption('LFGrole', tm_backup['options']['LFGrole'])
			for i, index in pairs(tm_constants['lfgGearsetGroup']) do
				setPlayerSetting(index, tm_backup['user'][index])
			end
		end

		tm_widgets['panel3']['panel'].default = function(self)
			--print('gearpanel default')
			default_profile = defaultProfile()
			for i, index in pairs(tm_constants['MainGearsetGroup']) do
				setPlayerSetting(index, default_profile['user'][index])
			end
			setPlayerOption('LFGrole', default_profile['options']['LFGrole'])
			for i, index in pairs(tm_constants['lfgGearsetGroup']) do
				setPlayerSetting(index, default_profile['user'][index])
			end
			tm_widgets['panel3']['panel'].refresh()
		end

		-- Classify as another child panel
		tm_widgets['panel3']['panel'].parent = tm_constants['Panel1Name']
		tm_widgets['panel3']['panel'].name = tm_constants['Panel3Name']
		InterfaceOptions_AddCategory(tm_widgets['panel3']['panel'])
	end
end
function createAdvancedPanel()
-- Create a panel for advanced user settings - in development still
	if not tm_widgets['panel4'] then 
		local temp
		tm_widgets['panel4'] = {}
		tm_widgets['panel4']['panel'] = CreateFrame('Frame', 'TabardMasterAdvanced', InterfaceOptionsFramePanelContainer)
		tm_widgets['panel4']['title'] = createTextField(tm_widgets['panel4']['panel'], tm_constants['TITLEFONT'], nil, 16, -16)
		tm_widgets['panel4']['title']:SetText(tm_lang['advancedpanelsubtitle'])
		tm_widgets['panel4']['subTitle'] = createTextField(tm_widgets['panel4']['panel'], tm_constants['SUBTITLEFONT'], 42, 16, -28)
		tm_widgets['panel4']['subTitle']:SetPoint('RIGHT', tm_widgets['panel4']['panel'], -16, 0)
		tm_widgets['panel4']['subTitle']:SetText(tm_lang['advancedpanelsubtitle'])

		-- create / edit custom tabard categories
		-- change default tabard categories
		-- the 'newZone' entry
--[[	tm_widgets['panel4']['nzMenu'] = CreateFrame('Button', 'nzMenuName', tm_widgets['panel4']['panel'], 'UIDropDownMenuTemplate')
		tm_widgets['panel4']['nzMenu']:SetPoint('TOPLEFT', 16, -200)
		tm_widgets['panel4']['nzMenu'].Items = {}
		temp = getPlayerOption('newZone')
		for k, v in pairs(tm_constants['DungeonZones']) do
			tm_widgets['panel4']['nzMenu'].Items[k] = v
			if temp == v then --tm_widgets['panel4']['nzMenu'].Selected = k; end
				UIDropDownMenu_SetSelectedID(tm_widgets['panel4']['nzMenu'], k)
			end
		end
		local function nz_initialize(self, level)
			for k, v in pairs(tm_widgets['panel4']['nzMenu'].Items) do
				local info = UIDropDownMenu_CreateInfo()
				info.text = v
				info.value = v		-- not necessary; frameXML code dupes text field to value field
				info.padding = 8
				info.leftPadding = 8
				info.notCheckable = true
				info.func = function(self) UIDropDownMenu_SetSelectedID(tm_widgets['panel4']['nzMenu'], self:GetID()); end
				UIDropDownMenu_AddButton(info, level)
			end 
		end		
		UIDropDownMenu_Initialize(tm_widgets['panel4']['nzMenu'], nz_initialize)
		UIDropDownMenu_SetSelectedID(tm_widgets['panel4']['nzMenu'], tm_widgets['panel4']['nzMenu'].Selected)
		tm_widgets['panel4']['nzText'] = createTextField(tm_widgets['panel4']['panel'], tm_constants['MAINGROUPFONT'], nil, nil, nil)
		tm_widgets['panel4']['nzText']:SetText('Zone category assigned to new zones')
		--tm_widgets['panel4']['nzText']:SetPoint('LEFT', tm_widgets['panel4']['nzMenu'], tm_widgets['panel4']['nzMenu']:GetWidth() + 16, -20)
		tm_widgets['panel4']['nzText']:SetPoint('LEFT', tm_widgets['panel4']['nzMenu'], 'LEFT', 0, -20)

print('nzMenu.Width=', tm_widgets['panel4']['nzMenu']:GetWidth())		-- 40
-- print('nzMenuButton.Width=', tm_widgets['panel4']['nzMenu']:GetButtonWidth())		-- error
--	local l, b, w, h = tm_widgets['panel4']['nzMenu']:GetBoundsRect()  -- nil, nil, nil, nil
-- print('Bounds: Left', l, 'Bottom', b, 'Width', w, 'Height', h)		
--print('UImenu:Left=', UIDROPDOWNMENU_OPEN_MENU:GetName().."Left")		--error
--print('nzMenuText.Width=', tm_widgets['panel4']['nzMenu'] .. 'Text':GetWidth())		-- error
--print('nzMenu MaxButtonWidth=', UIDropDownMenu_GetMaxButtonWidth(tm_widgets['panel4']['nzMenu']))	--error
--print('nzMenu GetButtonWidth=', UIDropDownMenu_GetButtonWidth(tm_widgets['panel4']['nzMenu']))	--error
]]

		
		-- timers
		tm_widgets['panel4']['timerPanel'] = createFilledPanel(tm_widgets['panel4']['panel'], nil, nil, nil, nil)
		tm_widgets['panel4']['timerPanel'].title:SetFormattedText(tm_constants['stringWhite'], tm_lang['timerpaneltitle'])
		-- Create 4 timers, sequenced by tm_contants['Timers'], where
		-- 	timer1 'delayZoneChanges'		(default 3)		timer3 'delayReputationChanges'	(default 2)
		-- 	timer2 'blockZoneChanges'		(default 7)		timer4 'blockReputationChanges'	(default 10)

		for index, option in ipairs(tm_constants['Timers']) do
			local widgetName = 'timer' .. index
			tm_widgets['panel4'][widgetName] = createSlider('Slider' .. index, tm_widgets['panel4']['timerPanel'], 0, 30)
			tm_widgets['panel4'][widgetName].tooltipText = tm_lang[option .. 'Tooltip']
			tm_widgets['panel4'][widgetName]:SetHeight(16)
			tm_widgets['panel4'][widgetName]:SetValueStep(1)
			tm_widgets['panel4'][widgetName].textLow:SetText('Off')
			tm_widgets['panel4'][widgetName].textHigh:SetText('30')
			tm_widgets['panel4'][widgetName]:SetScript("OnValueChanged", function (self, value) -- runs both at set and change
				value = floor(value)			-- despite SetValueStep above, still getting fractionals, :GetValue too.
				setPlayerOption(option, value)
				if value > 0 then
					if value > 1 then
						tm_widgets['panel4'][widgetName].text:SetFormattedText(tm_lang[option .. 'Plural'], value)
					else
						tm_widgets['panel4'][widgetName].text:SetFormattedText(tm_lang[option .. 'Single'], value)
					end
				else
					tm_widgets['panel4'][widgetName].text:SetText(tm_lang[option .. 'Off'])
				end
			end)
		end

		--Set panel's event handlers
		tm_widgets['panel4']['panel']:SetScript('OnShow', function() 
			backupProfile()
		end)
		
		tm_widgets['panel4']['panel'].refresh = function(self)
			local w = math.floor(InterfaceOptionsFramePanelContainer:GetWidth() + .5) - 32	-- space 16 left & right
			if tm_widgets['panel4']['timerPanel']:GetWidth() ~= w then 
				tm_widgets['panel4']['timerPanel']:SetWidth(w)
				tm_widgets['panel4']['timerPanel']:SetHeight(108)
				tm_widgets['panel4']['timerPanel']:SetPoint('TOPLEFT', 16, (-1 * math.floor(InterfaceOptionsFramePanelContainer:GetHeight() + .5)) + tm_widgets['panel4']['timerPanel']:GetHeight() + 8)
				local widgetWidth = math.floor((w - 64) / 2)	 -- width of timer sider widgets is 1/2 window width, less 16 pixel side margins (16 * 4)
				for i, timerNum in pairs({'timer1', 'timer2', 'timer3', 'timer4'}) do
					tm_widgets['panel4'][timerNum]:SetWidth(widgetWidth); end
				tm_widgets['panel4']['timer1']:SetPoint('TOPLEFT', 16, -28)
				tm_widgets['panel4']['timer2']:SetPoint('TOPLEFT', 16, -72)
				tm_widgets['panel4']['timer3']:SetPoint('TOPRIGHT', -16, -28)
				tm_widgets['panel4']['timer4']:SetPoint('TOPRIGHT', -16, -72)
			end
			for i, option in ipairs(tm_constants['Timers']) do
				tm_widgets['panel4']['timer' .. i]:SetValue(getPlayerOption(option)); end
		end
		
		tm_widgets['panel4']['panel'].okay = function(self)
--			setPlayerOption('newZone', UIDropDownMenu_GetText(tm_widgets['panel4']['nzMenu']))
		end
		tm_widgets['panel4']['panel'].cancel = function(self)
			for i, index in pairs(tm_constants['Timers']) do 
				setPlayerOption(index, tm_backup['options'][index])
			end
		end
		tm_widgets['panel4']['panel'].default = function(self)
			default_Profile = defaultProfile()
			for i, index in pairs(tm_constants['Timers']) do 
				setPlayerOption(index, default_Profile['options'][index])
			end			
		end

		tm_widgets['panel4']['panel'].parent = tm_constants['Panel1Name']
		tm_widgets['panel4']['panel'].name = tm_constants['Panel4Name']
		InterfaceOptions_AddCategory(tm_widgets['panel4']['panel'])
	end
end
function createAboutPanel()
-- Add an 'About' Panel
	if not tm_widgets['panel5'] then
		tm_widgets['panel5'] = {}
		tm_widgets['panel5']['panel'] = CreateFrame('Frame', 'TabardMasterAbout', InterfaceOptionsFramePanelContainer)
		tm_widgets['panel5']['title'] = createTextField(tm_widgets['panel5']['panel'], 'GameFontNormalLarge', nil, 16, -16)
		tm_widgets['panel5']['title']:SetText(tmTitle .. ' - ' .. tm_lang['aboutpaneltitle'])

		tm_widgets['panel5']['lines'] = {}
		for i, line in ipairs(tm_lang['iofAboutPanel']) do
			tm_widgets['panel5']['lines'][i] = createTextField(tm_widgets['panel5']['panel'], 'GameFontHighlightSmall', 35, 16, -16 - (tm_widgets['widgetVspace'] * i))
			tm_widgets['panel5']['lines'][i]:SetPoint('RIGHT', tm_widgets['panel5']['panel'], -16, 0)
			tm_widgets['panel5']['lines'][i]:SetText(gsub(line, '%%version', tmVersion))
		end

--[[	this panel has nothing to do in these events
		tm_widgets['panel5']['panel']:SetScript('OnShow', function() 
		end)
		tm_widgets['panel5']['panel'].refresh = function(self)
		end
		tm_widgets['panel5']['panel'].okay = function(self)
		end
		tm_widgets['panel5']['panel'].cancel = function(self)
		end
		tm_widgets['panel5']['panel'].default = function(self)
		end
]]--
		
		-- Classify as another child panel
		tm_widgets['panel5']['panel'].parent = tm_constants['Panel1Name']
		tm_widgets['panel5']['panel'].name = tm_constants['Panel5Name']
		InterfaceOptions_AddCategory(tm_widgets['panel5']['panel'])
	end
end
-- End Options Panels


-- LDB code; replaced minimap button code v118
function tm_LDB_OnClick(frame, button)
	if tmTooltip and tmTooltip:IsVisible() then tmTooltip:Hide(); end
	if button == 'LeftButton' then
		quickMenu()
	elseif button == "RightButton" then
		iofOpenPanel(tm_constants['Panel1Name'])
	end
end
function tm_LDB_tooltipShow(tooltip)
	-- creates a small popup on the LDB button
	tmTooltip = tooltip
	tmTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE .. tmTitle .. FONT_COLOR_CODE_CLOSE)
	tooltip:AddLine("|cffff8040" .. tm_lang["Left Click"] .. '|r' .. tm_lang[' for quick change menu'])
	tooltip:AddLine("|cffff8040" .. tm_lang["Right Click"] .. '|r' .. tm_lang[' for options'])
	tmTooltip:Show()
end
---- End LDB code


-- Event driven
function startMeUp()
-- Our 'ADDON_LOADED' event handler
	-- New install or version changed; create or change stored data as necessary
	if not tm_global['version'] then tm_global['version'] = 0; end				-- 0 is new install, version updated below
	
	-- Update global profile; should normally only run once per account
	if extraVersion or tm_global['version'] ~= tmVersion then					-- update globals on new or test TabardMaster version 
		if tm_global['version'] > 0 then
			-- message box to inform player of latest changes, update tm_lang['mbox_message1'] with new info
			if tm_global['version'] < 109 then									-- v109 changed how LFG role gearsets work
				StaticPopupDialogs['TM_POPUPBOX'] = {
					text = tm_lang['mbox_message1'],
					timeout = 15,
					button1 = OKAY,
					button2 = nil,
					whileDead = true,
					hideOnEscape = true,
					OnAccept = function() return; end,
				}
				StaticPopup_Show('TM_POPUPBOX')
			end
		end
		-- Update global variables as needed
		if tm_global['maps'] then tm_global['maps'] = nil; end					-- renamed to "newZones" in v102
		if tm_global['chat'] then tm_global['chat'] = nil; end					-- clear out debug captures
		if tm_global['log'] then tm_global['log'] = nil; end					-- clear out log captures
		if tm_global['newZones'] then tm_global['newZones'] = nil; end			-- tm_global['newZones'] no longer used; v118
		-- footprints tracking removed v124
		if tm_global['options']['footprints'] ~= nil then tm_global['options']['footprints'] = nil; end
		if tm_global['footprints'] then	tm_global['footprints'] = nil; end
		if tm_global['reputation'] then tm_global['reputation'] = nil; end		-- 114 removed global reputation tracking
		if not tm_global['exalted'] then tm_global['exalted'] = {}; end			-- global reputation tracking added back 124
		--[[ The original idea behind capturing global reputation was to emphasize collecting city faction mounts; individual 
			characters would work towards different city reputations.  The idea predates account-wide mounts and can now be
			achieved by giving each character a different city tabard instead.  Exalted city factions would be de-emphasized.
			Reputation isn't just for the mounts though.  With v124, tracking has been changed to true / false for each 
			exalted city faction.  Not sure where this is going yet though.  May make this an option in a later version; 
			kinda running out of space for more options on main panel though.											]]--
		-- set / check global options
		if not tm_global['options'] then tm_global['options'] = {}; end
		if tm_global['options']['zoneFrame'] then								-- "zoneFrame" renamed "infoFrame" v120
			tm_global['options']['infoFrame'] = tm_global['options']['zoneFrame']
			tm_global['options']['zoneFrame'] = nil
			tm_global['options']['infoFrameX'] = tm_global['options']['zoneFrameX']
			tm_global['options']['zoneFrameX'] = nil
			tm_global['options']['infoFrameY'] = tm_global['options']['zoneFrameY']
			tm_global['options']['zoneFrameY'] = nil
		end
		tm_global['version'] = tonumber(string.match(tmVersion, '%d+'))			-- Store TabardMaster version #
	end

	-- Update individual character profiles
	if tm_player['version'] then												-- character profile exists
		if extraVersion or tm_player['version'] ~= tmVersion then				-- Update character profile
			local new_profile = defaultProfile()								-- create a temporary, default player profile
			
			-- Perform any necessary pre-processing to values
			if tm_player['options']['minimapPos'] then							-- minimap value changes from integer to table in v118,
				tm_player['options']['minimapSave'] = tm_player['options']['minimap'] 
				tm_player['options']['minimap'] = nil							-- so save previous on/off value
			end

			 -- overwrite this entry with default profile one instead
			 if tm_player['options']['newZone'] then tm_player['options']['newZone'] = nil; end
			 
			-- Overwrite existing new profile fields with existing player values; go 3 levels deep only.
			for key1, val1 in pairs(tm_player) do
				if new_profile[key1] ~= nil then
					if type(tm_player[key1]) == 'table' then
						for key2, val2 in pairs(tm_player[key1]) do
							if new_profile[key1][key2] ~= nil then
								if type(tm_player[key1][key2]) == 'table' then
									for key3, val3 in pairs(tm_player[key1][key2]) do
										if new_profile[key1][key2][key3] ~= nil then
											new_profile[key1][key2][key3] = val3
										end
									end
								else
									new_profile[key1][key2] = val2
								end
							end
						end
					else
						new_profile[key1] = val1
					end
				end
			end

			-- Modify any saved player variables as needed
			if tm_player['options']['minimapPos'] then							-- convert minimap info to table, v118
				new_profile['options']['minimap']['hide'] = (tm_player['options']['minimapSave'] or 1) < 1
				new_profile['options']['minimap']['minimapPos'] = tm_player['options']['minimapPos']
			end			

			if tm_player['tabards'] and tm_player['tabards']['none'] then 		-- renamed v097c
				new_profile['user']['solo'] = tm_player['tabards']['none']
			end

			if tm_player['gearset'] and tm_player['gearset']['lfgRole1'] then	-- gearset role names changed v106
				new_profile['user']['lfgTANK']		= tm_player['gearset']['lfgRole1']
				new_profile['user']['lfgHEALER']	= tm_player['gearset']['lfgRole2']
				new_profile['user']['lfgDAMAGER']	= tm_player['gearset']['lfgRole3']
				new_profile['user']['lfgNONE']		= tm_player['gearset']['lfgRole4']
			end

			-- Garrisons (& class halls) index renamed to 'home'
			if tm_player['tabards'] and tm_player['tabards']['garrison'] then new_profile['user']['homeTabard'] = tm_player['tabards']['garrison']; end
			if tm_player['gearset'] and tm_player['gearset']['garrison'] then new_profile['user']['homeGear'] = tm_player['gearset']['garrison']; end
			if tm_player['category'] and tm_player['category']['garrison'] then new_profile['category']['home'] = tm_player['category']['garrison']; end
			
			-- storage format for player choices changed 118; 'tabards' & 'gearset' tables merged into 'user' table
			if tm_player['tabards'] then
				for group, tabard in pairs({'solo', 'city', 'home', 'raid', 'pvp'}) do	-- main & GearMaster pages
					if tm_player['tabards'][tabard] then new_profile['user'][group .. 'Tabard'] = tm_player['tabards'][tabard]; end
					if tm_player['gearset'][group] then new_profile['user'][group .. 'Gear'] = tm_player['gearset'][group]; end
				end
				for group, tabard in pairs(tm_constants['DungeonZones']) do 	-- dungeon page entries
					if tm_player['tabards'][tabard] then new_profile['user'][group .. 'Tabard'] = tm_player['tabards'][tabard]; end
				end
				for index, gear in pairs(tm_player['gearset']) do				-- this gearset marker is now 'false'
					if gear == 'DoNOTchangeGear' then tm_player['gearset'][index] = false; end
				end
				for i, group in pairs(tm_constants['lfgGearsetGroup'] ) do 		-- slightly different
					if tm_player['gearset'][group] then new_profile['user'][group] = tm_player['gearset'][group]; end
				end
			end

			-- Finalize the new character profile
			tm_player = CopyTable(new_profile)									-- copy new profile to player profile
			
			-- Validate what we just loaded.  Debug state not stored in character profile if false, minimap data is not checked
			new_profile = defaultProfile()										-- reset to default values
			-- Check verbose (0-3) & tracker (0-2) settings
			setPlayerOption('verbose', checkRangedOption(getPlayerOption('verbose'), new_profile['options']['verbose'], 0, 3))	-- Level of chat window feedback
			setPlayerOption('tracker', checkRangedOption(getPlayerOption('tracker'), new_profile['options']['tracker'], 0, 2))	-- Reputation bar follows tabard
			-- Check the timer values are 0 - 30 (seconds)
			for index, option in pairs(tm_constants['Timers']) do
				setPlayerOption(option, checkRangedOption(getPlayerOption(option), new_profile['options'][option], 0, 30))
			end	
			-- Check all the true / false options
			for index, option in pairs(tm_constants['OnOffOptions']) do 
				setPlayerOption(option, checkToggleOption(getPlayerOption(option), new_profile['options'][option]))
			end	
			-- Check if character's newZone entry is valid, and that tabard categories reference valid tm_tabardGroup entries (added 111) 
			local verified = false
			for index, default in pairs(new_profile['category']) do	
				local current = getPlayerCategory(index)
				if not tm_tabardGroup[current] then setPlayerCategory(index, default); end	
				if getPlayerOption('newZone') == index then verified = true; end
			end
			if not verified then setPlayerOption('newZone', new_profile['options']['newZone']); end	-- set tm_player['options']['newZone'] to a valid category

			tm_player['version'] = tonumber(string.match(tmVersion, '%d+'))		-- change the profile version #
			dprint('Character profile updated')
		end
	else
		tm_player = defaultProfile()											-- New character; assign the default profile
		dprint('Character profile created')
	end

--	-- Collect map data in new client versions - not used any more
--	local clientVersion = (select(4, GetBuildInfo()))							-- Game client build version #
--	if not tm_global['client'] or tm_global['client'] ~= clientVersion then
--		tm_global['client'] = clientVersion										-- Save client build #
--		-- Add code as necessary
--	end
	if tm_global['client'] then tm_global['client'] = nil; end

	-- generate GetItemInfo() requests for all tabards; see note RE: data cache in validateTabard()
	local tabard = getCurrentTabard()
	if tabard > 0 then GetItemInfo(tabard); end
	for i, index in pairs(tm_constants['MainTabardGroup']) do 					-- main options page entries
		tabard = tonumber(getPlayerSetting(index)) or 0
		if tabard > 0 then GetItemInfo(tabard); end
	end
	for i, index in pairs(tm_constants['DungeonTabardGroup']) do 				-- dungeon page entries
		tabard = tonumber(getPlayerSetting(index)) or 0
		if tabard > 0 then GetItemInfo(tabard); end
	end
	tabard = nil	
	
-- Reputation rankings; these shouldn't require localizing as the getglobal() calls retrieve the localized text already.
--	format: %c and %m (Note the double %) will be replaced with current and maximum reputation for current rank.  IE: 'Exalted (999/1000)'
-- 	The male and female FACTION_STANDING_LABELx entries are the same in the English UI clients, but may not be so for other languages.
--	Can be overridden in language file for alternate layouts if necessary.
	if UnitSex('player') < 3 then 												-- 1 = unspecified, 2 = male, 3 = female
		tm_reputations[0] = string.format(tm_constants['stringRed'], 'Undefined')-- male characters
		tm_reputations[1] = tm_lang['malerank1'] or "|cFFA75219" .. getglobal("FACTION_STANDING_LABEL1") .. " (%%c/%%m)|r"			-- Hated
		tm_reputations[2] = tm_lang['malerank2'] or "|cFFA75219" .. getglobal("FACTION_STANDING_LABEL2") .. " (%%c/%%m)|r"			-- Hostile
		tm_reputations[3] = tm_lang['malerank3'] or "|cFFAA7419" .. getglobal("FACTION_STANDING_LABEL3") .. " (%%c/%%m)|r"			-- Unfriendly
		tm_reputations[4] = tm_lang['malerank4'] or "|cFFA68818" .. getglobal("FACTION_STANDING_LABEL4") .. " (%%c/%%m)|r"			-- Neutral
		tm_reputations[5] = tm_lang['malerank5'] or "|cFF777601" .. getglobal("FACTION_STANDING_LABEL5") .. " (%%c/%%m)|r"			-- Friendly
		tm_reputations[6] = tm_lang['malerank6'] or "|cFF527001" .. getglobal("FACTION_STANDING_LABEL6") .. " (%%c/%%m)|r"			-- Honored
		tm_reputations[7] = tm_lang['malerank7'] or "|cFF217201" .. getglobal("FACTION_STANDING_LABEL7") .. " (%%c/%%m)|r"			-- Revered
		tm_reputations[8] = tm_lang['malerank8'] or "|cFF056d01" .. getglobal("FACTION_STANDING_LABEL8") .. " (%%c/%%m)|r"			-- Exalted
	else
		tm_reputations[0] = string.format(tm_constants['stringRed'], 'Undefined')-- female characters
		tm_reputations[1] = tm_lang['femalerank1'] or "|cFF861C10" .. getglobal("FACTION_STANDING_LABEL1_FEMALE") .. " (%%c/%%m)|r"	-- Hated
		tm_reputations[2] = tm_lang['femalerank2'] or "|cFFA75219" .. getglobal("FACTION_STANDING_LABEL2_FEMALE") .. " (%%c/%%m)|r"	-- Hostile
		tm_reputations[3] = tm_lang['femalerank3'] or "|cFFAA7419" .. getglobal("FACTION_STANDING_LABEL3_FEMALE") .. " (%%c/%%m)|r"	-- Unfriendly
		tm_reputations[4] = tm_lang['femalerank4'] or "|cFFA68818" .. getglobal("FACTION_STANDING_LABEL4_FEMALE") .. " (%%c/%%m)|r"	-- Neutral
		tm_reputations[5] = tm_lang['femalerank5'] or "|cFF777601" .. getglobal("FACTION_STANDING_LABEL5_FEMALE") .. " (%%c/%%m)|r"	-- Friendly
		tm_reputations[6] = tm_lang['femalerank6'] or "|cFF527001" .. getglobal("FACTION_STANDING_LABEL6_FEMALE") .. " (%%c/%%m)|r"	-- Honored
		tm_reputations[7] = tm_lang['femalerank7'] or "|cFF217201" .. getglobal("FACTION_STANDING_LABEL7_FEMALE") .. " (%%c/%%m)|r"	-- Revered
		tm_reputations[8] = tm_lang['femalerank8'] or "|cFF056d01" .. getglobal("FACTION_STANDING_LABEL8_FEMALE") .. " (%%c/%%m)|r"	-- Exalted
	end	-- NOTE: Blizzard's color values for each reputation level are found in the table FACTION_BAR_COLORS; I prefer these.

	-- Process any custom overrides
	if tm_tabardGroup['override'] then 											--  override tabard categories 
		for category, swap in pairs(tm_tabardGroup['override']) do
			if category == 'override' or type(swap) ~= 'string' then break; end	-- abusive user checks
			if string.len(swap) > 3 and tm_tabardGroup[category] then
				tm_tabardGroup[category] = swap									-- reassign
			end
		end
		tm_tabardGroup['override'] = nil										-- Cleanup; erase the override
	end	
	if tm_maps['override'] then 												--  override mapID assignments; 114
		for zone, mapIDlist in pairs(tm_maps['override']) do
			if zone == 'override' or type(mapIDlist) ~= 'string' then break; end	-- checks for abusive user!
			if tm_maps[zone] then												-- check for valid destination zone
				for mapID in string.gmatch(mapIDlist, "%d+") do					-- get each reassigned mapID
					tm_maps[zone] = tm_maps[zone] .. ' ' .. mapID				-- and add to new zone
					for index, maplist in pairs(tm_maps) do						-- find original mapID assignment
						if index ~= zone and type(maplist) == 'string' then		-- (sanity check)
							for map in string.gmatch(maplist, "%d+") do
								if tonumber(map) == mapID then 
									tm_maps[index] = string.gsub(maplist, map, 'XXX') -- and deface it
									break
								end
							end
						end
					end
				end			
			end
		end
		tm_maps['override'] = nil												-- Cleanup; erase the override
	end

	-- Copy stored LDB data to working store
	mmIconBuffer = CopyTable(tm_player['options']['minimap'])

	-- Connect to external libraries; 118
	local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
	if ldb then
		tm_LDB_Object = ldb:NewDataObject(tmTitle, {
			label = tmTitle, 
			type = "data source", 
			icon = "Interface\\Icons\\INV_Misc_Tabard_Lorewalkers", 
			text = "", -- shows on right side of label
			OnClick = tm_LDB_OnClick,
			OnTooltipShow = tm_LDB_tooltipShow,
			OnTooltipHide = function() tmTooltip = nil; end,
		})
		if tm_LDB_Object then		
			mmIcon = LibStub("LibDBIcon-1.0")
			mmIcon:Register(tmTitle, tm_LDB_Object, mmIconBuffer)
			mmIcon:Refresh(tmTitle)
		end
	end	
	
	--getAllegianceName()														-- see what side we fight for
	createMainPanel()															-- & create the option panels
	createInstancePanel()
	createGearMasterPanel()
	createAdvancedPanel()
	createAboutPanel()

	playerLevel = UnitLevel('player')											-- set global playerLevel & 
	setUsageState()																-- widget usage markers
	
	-- Announce ourself
	local tmTemporary = '|cFFFF00FF' .. tm_lang['intro'] .. '|r'				-- was cFFFF00C80
	tmTemporary = gsub(tmTemporary, '%%t', tmTitle)
	tmTemporary = gsub(tmTemporary, '%%v', tmVersion)
	print(tmTemporary)
end
-- end Event driven


function tm_EventHandler(self, event, arg1, ...)
-- Our event handler, loosely ordered by frequency of occurance
	--print('event', event, arg1)
	if event == 'CHANNEL_UI_UPDATE' then -- trigger changed v118
		startZonechangeTimer()
		
	elseif event == 'PLAYER_REGEN_DISABLED' then								-- use this event for start of combat
		if tmInfoFrame then tmInfoFrame.CB:SetText(string.format(tm_constants['stringRed'], tm_lang['infoframeCombat'])); end

	elseif event == 'PLAYER_REGEN_ENABLED' then									-- use this event for end of combat
		if tmInfoFrame then tmInfoFrame.CB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframeCombat'])); end
		exitCombatEventHandler()
	
	elseif event == 'PLAYER_FLAGS_CHANGED' then									-- 118 PVP handler 
		if UnitIsPVP('player') then
			if not flagPVP then 
				flagPVP = true
				if getPlayerOption('wearPvP') then startZonechangeTimer(true); end
				if tmInfoFrame then tmInfoFrame.PB:SetText(string.format(tm_constants['stringRed'], tm_lang['infoframePvP'])); end
			end
		else
			if flagPVP then 
				flagPVP = false
				if getPlayerOption('wearPvP') then startZonechangeTimer(); end
				if tmInfoFrame then tmInfoFrame.PB:SetText(string.format(tm_constants['stringGreen'], tm_lang['infoframePvP'])); end
			end
		end

	elseif event == 'QUEST_COMPLETE' and getPlayerOption('quest') then 			-- swap to a guild tabard for quest turn-in
		if InCombatLockdown() then												-- only weapon swaps allowed when in combat
			tm_widgets['panel1']['status']:SetText('Quest complete but tabard swaps not allowed when in combat')
			vprint(tm_lang['lockout'])
		end
		local i, tabard
		local currentTabard = getCurrentTabard()
		-- Guild tabards MUST be prioritized by bonus XP gain in tm_tabardGroup['guild']
		for i in string.gmatch(tm_tabardGroup[tm_player['category']['guild']], '%d+') do -- Loop thru guild tabard collection
			guildtabard = tonumber(i)
			if guildtabard == currentTabard then return; end 					-- we are are wearing the desired tabard already
			if GetItemCount(guildtabard) > 0 then								-- Desired guild tabard is in inventory, so
				swapTabard = currentTabard										-- save current tabard for swapping back into later
				EquipItemByName(guildtabard)									-- and wear chosen guild tabard
				vprint(gsub(tm_lang['tabardchange'], '%%t', guildtabard))
				tm_widgets['panel1']['status']:SetText(string.format('%s equipped for quest turn-in, old tabard is %s', getItemLink(guildtabard), getItemLink(swapTabard)))
				return															-- we don't need to continue looking for tabards
			end
		end
		return 																	-- A guild tabard is not available, abort
		
	elseif event == 'QUEST_FINISHED' and getPlayerOption('quest') then exitCombatEventHandler()
		
	elseif event == 'PLAYER_EQUIPMENT_CHANGED' then								-- Update reputation bar if tabard changes
		if arg1 == INVSLOT_TABARD then updateReputationBar(); end
		
	elseif event == 'UPDATE_FACTION' then startReputationTimer()
		
	elseif event == 'PLAYER_LEVEL_UP' then
		-- Update option panel displays as needed after a level up
		playerLevel = arg1
		dprint('Ding!  New level is', playerLevel)
		setUsageState()
		iofRefresh()
		
	elseif event == 'PLAYER_ENTERING_WORLD' then 
		tmFrame:UnregisterEvent('PLAYER_ENTERING_WORLD')
		startZonechangeTimer()
		
	elseif event == 'PLAYER_LEAVING_WORLD' then 								-- runs at player logouts and instance loads
		tm_player['options']['minimap']['hide'] = mmIconBuffer['hide']			-- copy LDB icon position to player store
		tm_player['options']['minimap']['radius'] = mmIconBuffer['radius']
		tm_player['options']['minimap']['minimapPos'] = floor(mmIconBuffer['minimapPos'] + .5)
		if tmInfoFrame then
			setGlobalOption('infoFrameX', floor(tmInfoFrame:GetLeft() + .5))	-- pixels from screen left
			setGlobalOption('infoFrameY', floor(tmInfoFrame:GetTop() + .5)) 	-- pixels from screen top
		end	
		-- Gather exalted reputation for each city faction
		--	47 = Ironforge, 54 = Gnomeregan, 68 = Undercity, 69 = Darnassus, 72 = Stormwind, 76 = Orgrimmar, 
		--	81 = Thunder Bluff, 530 = Darkspear Trolls, 911 = Silvermoon City, 930 = Exodar, 
		--	1133 = Bilgewater Cartel, 1134 = Gilneas, 1352 = Huojin Pandaren, 1353 = Tushui Pandaren		
		for i, factionID in pairs ({'47', '54', '68', '69', '72', '76', '81', '530', '911', '930', '1133', '1134', '1352', '1353'}) do
			if tm_reputationXRef[factionID].repRank and not tm_global['exalted'][factionID] then
				if tm_reputationXRef[factionID].repRank == tm_constants['EXALTED'] then
					tm_global['exalted'][factionID] = true
				end
			end
		end

	elseif event == 'ADDON_LOADED' then
		if arg1 ~= tmTitle then return; end										-- Wait for our turn; but we 
		tmFrame:UnregisterEvent('ADDON_LOADED') 									-- only need to do this once.
		blockZoneChanges = true													-- Block zone and
		blockReputationChanges = true											-- reputation events for now.
	
	elseif event == 'VARIABLES_LOADED' then
		tmFrame:UnregisterEvent('VARIABLES_LOADED') 								-- we only need to do this once
		-- Note: validate options now, but tababrds & gearsets are validated later with SKILL_LINES_CHANGED event
		startMeUp()
		-- Capture other events we need
		--tmFrame:RegisterEvent('PLAYER_ENTERING_WORD')							-- Capture Instance loads, etc
		--tmFrame:RegisterEvent('ZONE_CHANGED_NEW_AREA')						-- Capture zone changes
		tmFrame:RegisterEvent('CHANNEL_UI_UPDATE')								-- capture zone changes, v118
		tmFrame:RegisterEvent('UPDATE_FACTION')									-- reputation with a faction has changed
		tmFrame:RegisterEvent('PLAYER_REGEN_DISABLED')							-- combat starts, use instead of PLAYER_ENTER_COMBAT
		tmFrame:RegisterEvent('PLAYER_REGEN_ENABLED')							-- combat ends, use instead of PLAYER_LEAVE_COMBAT
		tmFrame:RegisterEvent('QUEST_COMPLETE')									-- wear a guild tabard at quest turn-in
		tmFrame:RegisterEvent('QUEST_FINISHED')									-- and take it off again
		tmFrame:RegisterEvent('SKILL_LINES_CHANGED')							-- see comments in event handler
		tmFrame:RegisterEvent('PLAYER_EQUIPMENT_CHANGED')						-- change rep bar to match tabard worn
		tmFrame:RegisterEvent('PLAYER_LEVEL_UP')								-- Level up!  Update status displays
		tmFrame:RegisterEvent('PLAYER_FLAGS_CHANGED')							-- capture pvp state changes
		tmFrame:RegisterEvent('PLAYER_LEAVING_WORLD')							-- Capture player logout
		C_Timer.After(5, resetZoneChangeBlock)									-- Enable zone & 
		C_Timer.After(5, resetReputationBlock)									-- reputation changes (Set at ADDON_LOADED)

	elseif event == 'SKILL_LINES_CHANGED' then									-- equipment sets are not available before this event 
		tmFrame:UnregisterEvent('SKILL_LINES_CHANGED') 							-- we only need to do this once
		validateAllTabards()
		validateAllGearsets()
		startReputationTimer()
		if UnitIsPVP('player') or UnitIsPVPFreeForAll('player') then flagPVP = true; end

	-- 	elseif event == '' ...		-- (add more event dispatchers here)
		
	end
end


function tm_SlashHandler(args, ...)
-- our slash command parser
	local arg = {} 																-- convert input string to individual words,
	for word in args:gmatch("%S+") do table.insert(arg, word:lower()); end		-- split on whitespace & convert to lower case

	local ON = tm_lang['on']
	local OFF = tm_lang['off']
-------------- Hidden (or Undocumented) commands --------------
	if arg[1] == 'debug' then 													-- enable / disable debug mode via '/tm debug'
		if getPlayerOption('verbose') == 3 or arg[2] == OFF then
			setPlayerOption('verbose', 2)
		else
			setPlayerOption('verbose', 3)
		end
		print(tm_lang['feedback state'][4])
		iofRefresh()

	-- move this feature into advanced tab
	elseif arg[1] == 'newzone' then												-- change player's newZone tabard category
		if arg[2] then
			for key, val in tm_player['category'] do
				if arg[2] == key.lower() then
					tm_player['options']['newZone'] = key
				end
			end
			-- need to add custom entry search still
		else
			print(string.format('Tabards used in unknown zones will be selected from %s category.  To change,', getPlayerOption('newZone')))
			print('use: /tm newzone category')
			print('Categories are D60, D70, D80, D85, D90, D100, D110, "guild", "cities", "pvp", "misc", "garrison", or a user category defined in custom.lua')
		end

	elseif arg[1] == tm_lang['info1'] or arg[1] == tm_lang['info2'] then		-- toggle visible state of info frame
		if tmInfoFrame then
			if arg[2] then
				if arg[2] == ON then tm_global['options']['infoFrame'] = true
				elseif arg[2] == OFF then tm_global['options']['infoFrame'] = false
				end
			else
				tm_global['options']['infoFrame'] = not tm_global['options']['infoFrame']
			end
			tmInfoFrame:Hide()
			if tm_global['options']['infoFrame'] then tmInfoFrame:Show(); end
		else print(tm_lang['noinfoframe'])
		end
-------------- End Hidden (or Undocumented) commands --------------

-------------- Development commands  --------------
	elseif arg[1] == 'a' then		-- open the advanced config panel
		iofOpenPanel(tm_constants['Panel4Name'])
-------------- End Development commands  --------------

	elseif arg[1] == '?' or arg[1] == tm_lang['help'] then
		print(tm_lang['helptext'])
		
	elseif arg[1] == tm_lang['lock1'] or arg[1] == tm_lang['lock2'] then		-- lock out tabard and gear changes this session
		if arg[2] then
			if arg[2] == 'ON' then tm_locked = true
			elseif arg[2] == 'OFF' then tm_locked = false
			else print('Tabard & gear swap lockout is', tm_locked)
			end
		else
			tm_locked = not tm_locked
		end
		
	elseif 	arg[1] == tm_lang['ts1'] or arg[1] == tm_lang['ts2'] then 			-- toggle tabard swapping
		if arg[2] then
			if arg[2] == ON then setPlayerOption('tabardswaps', true)
			elseif arg[2] == OFF then setPlayerOption('tabardswaps', false)
			else print('Tabard swapping is',getPlayerOption('tabardswaps'))
			end
		else
			setPlayerOption('tabardswaps', not getPlayerOption('tabardswaps'))
		end
		iofRefresh()
		
	elseif 	arg[1] == tm_lang['gs1'] or arg[1] == tm_lang['gs2'] then 			-- toggle gearset swapping
		if arg[2] then
			if arg[2] == ON then setPlayerOption('gearswaps', true)
			elseif arg[2] == OFF then setPlayerOption('gearswaps', false)
			else print('Gear swapping is',getPlayerOption('gearswaps'))
			end
		else
			setPlayerOption('gearswaps', not getPlayerOption('gearswaps'))
		end
		iofRefresh()
		
	elseif arg[1] == tm_lang['quiet1'] or arg[1] == tm_lang['quiet2'] then 		-- increment verbose message types
		local x = getPlayerOption('verbose') + 1
		if x > 2 then x = 0; end
		setPlayerOption('verbose', x)
		print(tm_lang['feedback state'][x + 1])
		iofRefresh()
		
	elseif arg[1] == tm_lang['dungeon1'] or arg[1] == tm_lang['dungeon2'] then	-- open the dungeon config panel
		iofOpenPanel(tm_constants['Panel2Name'])

	elseif arg[1] == tm_lang['gear1'] or arg[1] == tm_lang['gear2'] then		-- open the Gearmaster config panel
		iofOpenPanel(tm_constants['Panel3Name'])

	else
		iofOpenPanel(tm_constants['Panel1Name'])
	end
end


-- connections to the World (or at least the UI)
SLASH_TabardMaster1 = tm_lang['slash1']	-- "/tm"
SLASH_TabardMaster2 = tm_lang['slash2']	-- "/tabardmaster"
SlashCmdList['TabardMaster'] = tm_SlashHandler

-- Hook events we need for now, more will be captured later
tmFrame:RegisterEvent('ADDON_LOADED')											-- I'm ready to play!
tmFrame:RegisterEvent('VARIABLES_LOADED')										-- Profile is ready
tmFrame:RegisterEvent('PLAYER_ENTERING_WORLD')									-- Catch initial load area

-- Set our event handler
tmFrame:SetScript('OnEvent', tm_EventHandler)

-- Create popup for later use
StaticPopupDialogs['TM_POPUPBOX'] = {}

-- you were not prepared ...


--[[  Development notes ...

local function toboolean(x)		-- converts anything to true / false
	return not not x
end

put error message onscreen
	UIErrorsFrame:AddMessage("text", red, green, blue, messageId, holdTime)
	UIErrorsFrame:AddMessage('error message', 1.0, 0.1, 0.1, 1.0);
	
local factionLogoTextures = {
	["Alliance"]	= "Interface\\Timer\\Alliance-Logo",
	["Horde"]		= "Interface\\Timer\\Horde-Logo",
	["Neutral"]		= "Interface\\Timer\\Panda-Logo",
}
LFG_CATEGORY_NAMES = {
	[LE_LFG_CATEGORY_LFD] 		= 	LOOKING_FOR_DUNGEON,	-- 1
	[LE_LFG_CATEGORY_RF] 		= 	RAID_FINDER,			--
	[LE_LFG_CATEGORY_SCENARIO] 	= 	SCENARIOS,				-- 3
	[LE_LFG_CATEGORY_LFR] 		= 	LOOKING_FOR_RAID,		--
	[LE_LFG_CATEGORY_FLEXRAID] 	= 	FLEX_RAID,				--
	[LE_LFG_CATEGORY_WORLDPVP] 	= 	WORLD_PVP,				--
}

-- initial panel show sequence:
--	optionPanel 	OnShow
--	instancePanel 	OnShow
--	gearPanel 		OnShow
--	optionPanel 	Refresh
--	instancePanel 	Refresh
--	aboutPanel  	Refresh

]]
